require '_h2ph_pre.ph';

unless(defined(&AMIGAFFS_H)) {
    eval 'sub AMIGAFFS_H () {1;}' unless defined(&AMIGAFFS_H);
    require 'asm/byteorder.ph';
    require 'linux/types.ph';
    eval 'sub GET_END_PTR {
        local($st,$p,$sz) = @_;
	    eval q(((($p)+(($sz)-$sizeof{$st}))));
    }' unless defined(&GET_END_PTR);
    eval 'sub AFFS_GET_HASHENTRY {
        local($data,$hashkey) = @_;
	    eval q( &be32_to_cpu(($data)-> $hashtable[$hashkey]));
    }' unless defined(&AFFS_GET_HASHENTRY);
    eval 'sub AFFS_BLOCK {
        local($data,$ino,$blk) = @_;
	    eval q(($data)-> $blocks[ &AFFS_I2HSIZE($ino)-1-($blk)]);
    }' unless defined(&AFFS_BLOCK);
    eval 'sub FILE_END {
        local($p,$i) = @_;
	    eval q( &GET_END_PTR(\'struct file_end\',$p, &AFFS_I2BSIZE($i)));
    }' unless defined(&FILE_END);
    eval 'sub ROOT_END {
        local($p,$i) = @_;
	    eval q( &GET_END_PTR(\'struct root_end\',$p, &AFFS_I2BSIZE($i)));
    }' unless defined(&ROOT_END);
    eval 'sub DIR_END {
        local($p,$i) = @_;
	    eval q( &GET_END_PTR(\'struct dir_end\',$p, &AFFS_I2BSIZE($i)));
    }' unless defined(&DIR_END);
    eval 'sub LINK_END {
        local($p,$i) = @_;
	    eval q( &GET_END_PTR(\'struct hlink_end\',$p, &AFFS_I2BSIZE($i)));
    }' unless defined(&LINK_END);
    eval 'sub ROOT_END_S {
        local($p,$s) = @_;
	    eval q( &GET_END_PTR(\'struct root_end\',$p,($s)-> &s_blocksize));
    }' unless defined(&ROOT_END_S);
    eval 'sub DATA_FRONT {
        local($bh) = @_;
	    eval q((($bh)-> &b_data));
    }' unless defined(&DATA_FRONT);
    eval 'sub DIR_FRONT {
        local($bh) = @_;
	    eval q((($bh)-> &b_data));
    }' unless defined(&DIR_FRONT);
    eval 'sub affs_bread () { &bread;}' unless defined(&affs_bread);
    eval 'sub affs_brelse () { &brelse;}' unless defined(&affs_brelse);
    if(defined(&__LITTLE_ENDIAN)) {
	eval 'sub BO_EXBITS () {0x18;}' unless defined(&BO_EXBITS);
    }
 elsif(defined( &__BIG_ENDIAN)) {
	eval 'sub BO_EXBITS () {0x00;}' unless defined(&BO_EXBITS);
    } else {
	die("Endianness\ must\ be\ known\ for\ affs\ to\ work\.");
    }
    eval 'sub FS_OFS () {0x444f5300;}' unless defined(&FS_OFS);
    eval 'sub FS_FFS () {0x444f5301;}' unless defined(&FS_FFS);
    eval 'sub FS_INTLOFS () {0x444f5302;}' unless defined(&FS_INTLOFS);
    eval 'sub FS_INTLFFS () {0x444f5303;}' unless defined(&FS_INTLFFS);
    eval 'sub FS_DCOFS () {0x444f5304;}' unless defined(&FS_DCOFS);
    eval 'sub FS_DCFFS () {0x444f5305;}' unless defined(&FS_DCFFS);
    eval 'sub MUFS_FS () {0x6d754653;}' unless defined(&MUFS_FS);
    eval 'sub MUFS_OFS () {0x6d754600;}' unless defined(&MUFS_OFS);
    eval 'sub MUFS_FFS () {0x6d754601;}' unless defined(&MUFS_FFS);
    eval 'sub MUFS_INTLOFS () {0x6d754602;}' unless defined(&MUFS_INTLOFS);
    eval 'sub MUFS_INTLFFS () {0x6d754603;}' unless defined(&MUFS_INTLFFS);
    eval 'sub MUFS_DCOFS () {0x6d754604;}' unless defined(&MUFS_DCOFS);
    eval 'sub MUFS_DCFFS () {0x6d754605;}' unless defined(&MUFS_DCFFS);
    eval 'sub T_SHORT () {2;}' unless defined(&T_SHORT);
    eval 'sub T_LIST () {16;}' unless defined(&T_LIST);
    eval 'sub T_DATA () {8;}' unless defined(&T_DATA);
    eval 'sub ST_LINKFILE () {-4;}' unless defined(&ST_LINKFILE);
    eval 'sub ST_FILE () {-3;}' unless defined(&ST_FILE);
    eval 'sub ST_ROOT () {1;}' unless defined(&ST_ROOT);
    eval 'sub ST_USERDIR () {2;}' unless defined(&ST_USERDIR);
    eval 'sub ST_SOFTLINK () {3;}' unless defined(&ST_SOFTLINK);
    eval 'sub ST_LINKDIR () {4;}' unless defined(&ST_LINKDIR);
    eval 'sub FIBF_OTR_READ () {0x8000;}' unless defined(&FIBF_OTR_READ);
    eval 'sub FIBF_OTR_WRITE () {0x4000;}' unless defined(&FIBF_OTR_WRITE);
    eval 'sub FIBF_OTR_EXECUTE () {0x2000;}' unless defined(&FIBF_OTR_EXECUTE);
    eval 'sub FIBF_OTR_DELETE () {0x1000;}' unless defined(&FIBF_OTR_DELETE);
    eval 'sub FIBF_GRP_READ () {0x0800;}' unless defined(&FIBF_GRP_READ);
    eval 'sub FIBF_GRP_WRITE () {0x0400;}' unless defined(&FIBF_GRP_WRITE);
    eval 'sub FIBF_GRP_EXECUTE () {0x0200;}' unless defined(&FIBF_GRP_EXECUTE);
    eval 'sub FIBF_GRP_DELETE () {0x0100;}' unless defined(&FIBF_GRP_DELETE);
    eval 'sub FIBF_SCRIPT () {0x0040;}' unless defined(&FIBF_SCRIPT);
    eval 'sub FIBF_PURE () {0x0020;}' unless defined(&FIBF_PURE);
    eval 'sub FIBF_ARCHIVE () {0x0010;}' unless defined(&FIBF_ARCHIVE);
    eval 'sub FIBF_READ () {0x0008;}' unless defined(&FIBF_READ);
    eval 'sub FIBF_WRITE () {0x0004;}' unless defined(&FIBF_WRITE);
    eval 'sub FIBF_EXECUTE () {0x0002;}' unless defined(&FIBF_EXECUTE);
    eval 'sub FIBF_DELETE () {0x0001;}' unless defined(&FIBF_DELETE);
    eval 'sub FIBF_OWNER () {0x000f;}' unless defined(&FIBF_OWNER);
    eval 'sub AFFS_UMAYWRITE {
        local($prot) = @_;
	    eval q(((($prot) & ( &FIBF_WRITE| &FIBF_DELETE)) == ( &FIBF_WRITE| &FIBF_DELETE)));
    }' unless defined(&AFFS_UMAYWRITE);
    eval 'sub AFFS_UMAYREAD {
        local($prot) = @_;
	    eval q((($prot) &  &FIBF_READ));
    }' unless defined(&AFFS_UMAYREAD);
    eval 'sub AFFS_UMAYEXECUTE {
        local($prot) = @_;
	    eval q((($prot) &  &FIBF_EXECUTE));
    }' unless defined(&AFFS_UMAYEXECUTE);
    eval 'sub AFFS_GMAYWRITE {
        local($prot) = @_;
	    eval q(((($prot)( &FIBF_GRP_WRITE| &FIBF_GRP_DELETE))== ( &FIBF_GRP_WRITE| &FIBF_GRP_DELETE)));
    }' unless defined(&AFFS_GMAYWRITE);
    eval 'sub AFFS_GMAYREAD {
        local($prot) = @_;
	    eval q((($prot) &  &FIBF_GRP_READ));
    }' unless defined(&AFFS_GMAYREAD);
    eval 'sub AFFS_GMAYEXECUTE {
        local($prot) = @_;
	    eval q((($prot) &  &FIBF_EXECUTE));
    }' unless defined(&AFFS_GMAYEXECUTE);
    eval 'sub AFFS_OMAYWRITE {
        local($prot) = @_;
	    eval q(((($prot)( &FIBF_OTR_WRITE| &FIBF_OTR_DELETE))== ( &FIBF_OTR_WRITE| &FIBF_OTR_DELETE)));
    }' unless defined(&AFFS_OMAYWRITE);
    eval 'sub AFFS_OMAYREAD {
        local($prot) = @_;
	    eval q((($prot) &  &FIBF_OTR_READ));
    }' unless defined(&AFFS_OMAYREAD);
    eval 'sub AFFS_OMAYEXECUTE {
        local($prot) = @_;
	    eval q((($prot) &  &FIBF_EXECUTE));
    }' unless defined(&AFFS_OMAYEXECUTE);
}
1;
