require '_h2ph_pre.ph';

unless(defined(&_LINUX_ARCDEVICE_H)) {
    eval 'sub _LINUX_ARCDEVICE_H () {1;}' unless defined(&_LINUX_ARCDEVICE_H);
    require 'linux/config.ph';
    require 'linux/if_arcnet.ph';
    if(defined(&__KERNEL__)) {
	eval 'sub ARC_20020 () {1;}' unless defined(&ARC_20020);
	eval 'sub ARC_RIM_I () {2;}' unless defined(&ARC_RIM_I);
	eval 'sub ARC_90xx () {3;}' unless defined(&ARC_90xx);
	eval 'sub ARC_90xx_IO () {4;}' unless defined(&ARC_90xx_IO);
	eval 'sub MAX_ARCNET_DEVS () {8;}' unless defined(&MAX_ARCNET_DEVS);
	eval 'sub DETECT_RECONFIGS () {1;}' unless defined(&DETECT_RECONFIGS);
	undef(&SHOW_RECONFIGS) if defined(&SHOW_RECONFIGS);
	eval 'sub RECON_THRESHOLD () {30;}' unless defined(&RECON_THRESHOLD);
	eval 'sub TX_TIMEOUT () {(20* &HZ/100);}' unless defined(&TX_TIMEOUT);
	undef(&ALPHA_WARNING) if defined(&ALPHA_WARNING);
	eval 'sub D_NORMAL () {1;}' unless defined(&D_NORMAL);
	eval 'sub D_EXTRA () {2;}' unless defined(&D_EXTRA);
	eval 'sub D_INIT () {4;}' unless defined(&D_INIT);
	eval 'sub D_INIT_REASONS () {8;}' unless defined(&D_INIT_REASONS);
	eval 'sub D_DURING () {16;}' unless defined(&D_DURING);
	eval 'sub D_TX () {32;}' unless defined(&D_TX);
	eval 'sub D_RX () {64;}' unless defined(&D_RX);
	eval 'sub D_SKB () {128;}' unless defined(&D_SKB);
	unless(defined(&ARCNET_DEBUG_MAX)) {
	    eval 'sub ARCNET_DEBUG_MAX () {(~0);}' unless defined(&ARCNET_DEBUG_MAX);
	}
	unless(defined(&ARCNET_DEBUG)) {
	    eval 'sub ARCNET_DEBUG () {( &D_NORMAL| &D_EXTRA);}' unless defined(&ARCNET_DEBUG);
	}
	eval 'sub BUGLVL {
	    local($x) = @_;
    	    eval q( &if (( &ARCNET_DEBUG_MAX) &arcnet_debug($x)));
	}' unless defined(&BUGLVL);
	eval 'sub BUGMSG2 () {( &x, &msg, &args...)  &do {  &BUGLVL  &printk( &msg,   &args); }  &while (0);}' unless defined(&BUGMSG2);
	eval 'sub BUGMSG () {( &x, &msg, &args...)  &BUGMSG2( &x,"%s%6s: "  &msg,  &x== &D_NORMAL ?  &KERN_WARNING :  &x<= &D_INIT_REASONS ?  &KERN_INFO :  &KERN_DEBUG ,  ($dev->{name}) ,   &args);}' unless defined(&BUGMSG);
	eval 'sub SETMASK () { &AINTMASK( ($lp->{intmask}));}' unless defined(&SETMASK);
	eval 'sub RESETtime () {( &HZ * 3/ 10);}' unless defined(&RESETtime);
	eval 'sub MTU () {253;}' unless defined(&MTU);
	eval 'sub MinTU () {257;}' unless defined(&MinTU);
	eval 'sub XMTU () {508;}' unless defined(&XMTU);
	eval 'sub TXFREEflag () {0x01;}' unless defined(&TXFREEflag);
	eval 'sub TXACKflag () {0x02;}' unless defined(&TXACKflag);
	eval 'sub RECONflag () {0x04;}' unless defined(&RECONflag);
	eval 'sub TESTflag () {0x08;}' unless defined(&TESTflag);
	eval 'sub RESETflag () {0x10;}' unless defined(&RESETflag);
	eval 'sub RES1flag () {0x20;}' unless defined(&RES1flag);
	eval 'sub RES2flag () {0x40;}' unless defined(&RES2flag);
	eval 'sub NORXflag () {0x80;}' unless defined(&NORXflag);
	eval 'sub AUTOINCflag () {0x40;}' unless defined(&AUTOINCflag);
	eval 'sub IOMAPflag () {0x02;}' unless defined(&IOMAPflag);
	eval 'sub ENABLE16flag () {0x80;}' unless defined(&ENABLE16flag);
	eval 'sub NOTXcmd () {0x01;}' unless defined(&NOTXcmd);
	eval 'sub NORXcmd () {0x02;}' unless defined(&NORXcmd);
	eval 'sub TXcmd () {0x03;}' unless defined(&TXcmd);
	eval 'sub RXcmd () {0x04;}' unless defined(&RXcmd);
	eval 'sub CONFIGcmd () {0x05;}' unless defined(&CONFIGcmd);
	eval 'sub CFLAGScmd () {0x06;}' unless defined(&CFLAGScmd);
	eval 'sub TESTcmd () {0x07;}' unless defined(&TESTcmd);
	eval 'sub RESETclear () {0x08;}' unless defined(&RESETclear);
	eval 'sub CONFIGclear () {0x10;}' unless defined(&CONFIGclear);
	eval 'sub TESTload () {0x08;}' unless defined(&TESTload);
	eval 'sub TESTvalue () {0321;}' unless defined(&TESTvalue);
	eval 'sub RXbcasts () {0x80;}' unless defined(&RXbcasts);
	eval 'sub NORMALconf () {0x00;}' unless defined(&NORMALconf);
	eval 'sub EXTconf () {0x08;}' unless defined(&EXTconf);
	eval 'sub EnableReceiver () {
	    eval q( &ACOMMAND( &RXcmd|( &recbuf<<3)| &RXbcasts));
	}' unless defined(&EnableReceiver);
	eval 'sub JIFFER {
	    local($time) = @_;
    	    eval q( &for ( &delayval= &jiffies+$time;  &time_before( &jiffies, &delayval);) ;);
	}' unless defined(&JIFFER);
	eval 'sub EXTRA_CLIENTDATA () {($sizeof{\'struct ClientData\'}-4);}' unless defined(&EXTRA_CLIENTDATA);
	eval 'sub S_EXTRA_CLIENTDATA () {($sizeof{\'struct S_ClientData\'}-1);}' unless defined(&S_EXTRA_CLIENTDATA);
	if(defined( &DETECT_RECONFIGS)  && defined( &RECON_THRESHOLD)) {
	}
	if(defined(&CONFIG_ARCNET_ETH)) {
	}
	if(defined(&CONFIG_ARCNET_1051)) {
	}
	if((defined(&ARCNET_DEBUG_MAX) ? &ARCNET_DEBUG_MAX : 0) & (defined(&D_SKB) ? &D_SKB : 0)) {
	} else {
	    eval 'sub arcnet_dump_skb {
	        local($dev,$skb,$desc) = @_;
    		eval q(;);
	    }' unless defined(&arcnet_dump_skb);
	}
	if(((defined(&ARCNET_DEBUG_MAX) ? &ARCNET_DEBUG_MAX : 0) & (defined(&D_RX) ? &D_RX : 0)) || ((defined(&ARCNET_DEBUG_MAX) ? &ARCNET_DEBUG_MAX : 0) & (defined(&D_TX) ? &D_TX : 0))) {
	} else {
	    eval 'sub arcnet_dump_packet {
	        local($dev,$buffer,$ext,$desc) = @_;
    		eval q(;);
	    }' unless defined(&arcnet_dump_packet);
	}
    }
}
1;
