require '_h2ph_pre.ph';

unless(defined(&__ASOUND_H)) {
    eval 'sub __ASOUND_H () {1;}' unless defined(&__ASOUND_H);
    if(defined( &LINUX) || defined( &__LINUX__) || defined( &__linux__)) {
	require 'linux/ioctl.ph';
	require 'endian.ph';
	if((defined(&__BYTE_ORDER) ? &__BYTE_ORDER : 0) == (defined(&__LITTLE_ENDIAN) ? &__LITTLE_ENDIAN : 0)) {
	    eval 'sub SND_LITTLE_ENDIAN () {1;}' unless defined(&SND_LITTLE_ENDIAN);
	}
 elsif((defined(&__BYTE_ORDER) ? &__BYTE_ORDER : 0) == (defined(&__BIG_ENDIAN) ? &__BIG_ENDIAN : 0)) {
	    eval 'sub SND_BIG_ENDIAN () {1;}' unless defined(&SND_BIG_ENDIAN);
	}
    }
    unless(defined(&__KERNEL__)) {
	require 'sys/time.ph';
	require 'netinet/in.ph';
    } else {
	require 'linux/in.ph';
    }
    eval 'sub SND_PROTOCOL_VERSION {
        local($major, $minor, $subminor) = @_;
	    eval q(((($major)<<16)|(($minor)<<8)|($subminor)));
    }' unless defined(&SND_PROTOCOL_VERSION);
    eval 'sub SND_PROTOCOL_MAJOR {
        local($version) = @_;
	    eval q(((($version)>>16)&0xffff));
    }' unless defined(&SND_PROTOCOL_MAJOR);
    eval 'sub SND_PROTOCOL_MINOR {
        local($version) = @_;
	    eval q(((($version)>>8)&0xff));
    }' unless defined(&SND_PROTOCOL_MINOR);
    eval 'sub SND_PROTOCOL_MICRO {
        local($version) = @_;
	    eval q((($version)&0xff));
    }' unless defined(&SND_PROTOCOL_MICRO);
    eval 'sub SND_PROTOCOL_INCOMPATIBLE {
        local($kversion, $uversion) = @_;
	    eval q(( &SND_PROTOCOL_MAJOR($kversion) !=  &SND_PROTOCOL_MAJOR($uversion) || ( &SND_PROTOCOL_MAJOR($kversion) ==  &SND_PROTOCOL_MAJOR($uversion)  &&  &SND_PROTOCOL_MINOR($kversion) !=  &SND_PROTOCOL_MINOR($uversion))));
    }' unless defined(&SND_PROTOCOL_INCOMPATIBLE);
    eval 'sub snd_htoi_32 {
        local($val) = @_;
	    eval q( &htonl($val));
    }' unless defined(&snd_htoi_32);
    eval 'sub snd_htoi_16 {
        local($val) = @_;
	    eval q( &htons($val));
    }' unless defined(&snd_htoi_16);
    eval 'sub snd_itoh_32 {
        local($val) = @_;
	    eval q( &ntohl($val));
    }' unless defined(&snd_itoh_32);
    eval 'sub snd_itoh_16 {
        local($val) = @_;
	    eval q( &ntohs($val));
    }' unless defined(&snd_itoh_16);
    eval 'sub SND_CARDS () {8;}' unless defined(&SND_CARDS);
    eval 'sub SND_SW_TYPE_NONE () {0;}' unless defined(&SND_SW_TYPE_NONE);
    eval 'sub SND_SW_TYPE_BOOLEAN () {1;}' unless defined(&SND_SW_TYPE_BOOLEAN);
    eval 'sub SND_SW_TYPE_BYTE () {2;}' unless defined(&SND_SW_TYPE_BYTE);
    eval 'sub SND_SW_TYPE_WORD () {3;}' unless defined(&SND_SW_TYPE_WORD);
    eval 'sub SND_SW_TYPE_DWORD () {4;}' unless defined(&SND_SW_TYPE_DWORD);
    eval 'sub SND_SW_TYPE_LIST () {5;}' unless defined(&SND_SW_TYPE_LIST);
    eval 'sub SND_SW_TYPE_LIST_ITEM () {6;}' unless defined(&SND_SW_TYPE_LIST_ITEM);
    eval 'sub SND_SW_TYPE_LAST () {6;}' unless defined(&SND_SW_TYPE_LAST);
    eval 'sub SND_SW_TYPE_USER_READ_ONLY () {0xfffffffe;}' unless defined(&SND_SW_TYPE_USER_READ_ONLY);
    eval 'sub SND_SW_TYPE_USER () {0xffffffff;}' unless defined(&SND_SW_TYPE_USER);
    eval 'sub SND_SW_SUBTYPE_NONE () {0;}' unless defined(&SND_SW_SUBTYPE_NONE);
    eval 'sub SND_SW_SUBTYPE_HEXA () {1;}' unless defined(&SND_SW_SUBTYPE_HEXA);
    eval 'sub SND_CTL_IFACE_CONTROL () {0;}' unless defined(&SND_CTL_IFACE_CONTROL);
    eval 'sub SND_CTL_IFACE_MIXER () {1;}' unless defined(&SND_CTL_IFACE_MIXER);
    eval 'sub SND_CTL_IFACE_PCM () {2;}' unless defined(&SND_CTL_IFACE_PCM);
    eval 'sub SND_CTL_IFACE_RAWMIDI () {3;}' unless defined(&SND_CTL_IFACE_RAWMIDI);
    eval 'sub SND_CTL_VERSION () { &SND_PROTOCOL_VERSION(1, 0, 0);}' unless defined(&SND_CTL_VERSION);
    eval 'sub SND_CTL_SW_JOYSTICK () {"Joystick";}' unless defined(&SND_CTL_SW_JOYSTICK);
    eval 'sub SND_CTL_SW_JOYSTICK_ADDRESS () {"Joystick Address";}' unless defined(&SND_CTL_SW_JOYSTICK_ADDRESS);
    eval 'sub SND_CTL_SW_JOYSTICK_SPEED () {"Joystick Speed Compensation";}' unless defined(&SND_CTL_SW_JOYSTICK_SPEED);
    eval 'sub SND_CTL_IOCTL_PVERSION () { &_IOR (ord(\'U\'), 0x00, \'int\');}' unless defined(&SND_CTL_IOCTL_PVERSION);
    eval 'sub SND_CTL_IOCTL_HW_INFO () { &_IOR (ord(\'U\'), 0x01,  &snd_ctl_hw_info_t);}' unless defined(&SND_CTL_IOCTL_HW_INFO);
    eval 'sub SND_CTL_IOCTL_SWITCH_LIST () { &_IOWR(ord(\'U\'), 0x02,  &snd_switch_list_t);}' unless defined(&SND_CTL_IOCTL_SWITCH_LIST);
    eval 'sub SND_CTL_IOCTL_SWITCH_READ () { &_IOWR(ord(\'U\'), 0x03,  &snd_switch_t);}' unless defined(&SND_CTL_IOCTL_SWITCH_READ);
    eval 'sub SND_CTL_IOCTL_SWITCH_WRITE () { &_IOWR(ord(\'U\'), 0x04,  &snd_switch_t);}' unless defined(&SND_CTL_IOCTL_SWITCH_WRITE);
    eval 'sub SND_CTL_IOCTL_HWDEP_DEVICE () { &_IOW (ord(\'U\'), 0x08, \'int\');}' unless defined(&SND_CTL_IOCTL_HWDEP_DEVICE);
    eval 'sub SND_CTL_IOCTL_HWDEP_INFO () { &_IOR (ord(\'U\'), 0x09,  &snd_hwdep_info_t);}' unless defined(&SND_CTL_IOCTL_HWDEP_INFO);
    eval 'sub SND_CTL_IOCTL_MIXER_DEVICE () { &_IOW (ord(\'U\'), 0x10, \'int\');}' unless defined(&SND_CTL_IOCTL_MIXER_DEVICE);
    eval 'sub SND_CTL_IOCTL_MIXER_INFO () { &_IOR (ord(\'U\'), 0x10,  &snd_mixer_info_t);}' unless defined(&SND_CTL_IOCTL_MIXER_INFO);
    eval 'sub SND_CTL_IOCTL_PCM_DEVICE () { &_IOW (ord(\'U\'), 0x20, \'int\');}' unless defined(&SND_CTL_IOCTL_PCM_DEVICE);
    eval 'sub SND_CTL_IOCTL_PCM_CHANNEL () { &_IOW (ord(\'U\'), 0x21, \'int\');}' unless defined(&SND_CTL_IOCTL_PCM_CHANNEL);
    eval 'sub SND_CTL_IOCTL_PCM_SUBDEVICE () { &_IOW (ord(\'U\'), 0x22, \'int\');}' unless defined(&SND_CTL_IOCTL_PCM_SUBDEVICE);
    eval 'sub SND_CTL_IOCTL_PCM_PREFER_SUBDEVICE () { &_IOW(ord(\'U\'), 0x23, \'int\');}' unless defined(&SND_CTL_IOCTL_PCM_PREFER_SUBDEVICE);
    eval 'sub SND_CTL_IOCTL_PCM_INFO () { &_IOR (ord(\'U\'), 0x24,  &snd_pcm_info_t);}' unless defined(&SND_CTL_IOCTL_PCM_INFO);
    eval 'sub SND_CTL_IOCTL_PCM_CHANNEL_INFO () { &_IOR (ord(\'U\'), 0x25,  &snd_pcm_channel_info_t);}' unless defined(&SND_CTL_IOCTL_PCM_CHANNEL_INFO);
    eval 'sub SND_CTL_IOCTL_RAWMIDI_DEVICE () { &_IOW (ord(\'U\'), 0x30, \'int\');}' unless defined(&SND_CTL_IOCTL_RAWMIDI_DEVICE);
    eval 'sub SND_CTL_IOCTL_RAWMIDI_CHANNEL () { &_IOW (ord(\'U\'), 0x31, \'int\');}' unless defined(&SND_CTL_IOCTL_RAWMIDI_CHANNEL);
    eval 'sub SND_CTL_IOCTL_RAWMIDI_INFO () { &_IOR (ord(\'U\'), 0x32,  &snd_rawmidi_info_t);}' unless defined(&SND_CTL_IOCTL_RAWMIDI_INFO);
    eval 'sub SND_CTL_READ_REBUILD () {0;}' unless defined(&SND_CTL_READ_REBUILD);
    eval 'sub SND_CTL_READ_SWITCH_VALUE () {1;}' unless defined(&SND_CTL_READ_SWITCH_VALUE);
    eval 'sub SND_CTL_READ_SWITCH_CHANGE () {2;}' unless defined(&SND_CTL_READ_SWITCH_CHANGE);
    eval 'sub SND_CTL_READ_SWITCH_ADD () {3;}' unless defined(&SND_CTL_READ_SWITCH_ADD);
    eval 'sub SND_CTL_READ_SWITCH_REMOVE () {4;}' unless defined(&SND_CTL_READ_SWITCH_REMOVE);
    eval 'sub SND_HWDEP_VERSION () { &SND_PROTOCOL_VERSION(1, 0, 0);}' unless defined(&SND_HWDEP_VERSION);
    eval 'sub SND_HWDEP_TYPE_OPL2 () {0;}' unless defined(&SND_HWDEP_TYPE_OPL2);
    eval 'sub SND_HWDEP_TYPE_OPL3 () {1;}' unless defined(&SND_HWDEP_TYPE_OPL3);
    eval 'sub SND_HWDEP_TYPE_OPL4 () {2;}' unless defined(&SND_HWDEP_TYPE_OPL4);
    eval 'sub SND_HWDEP_TYPE_SB16CSP () {3;}' unless defined(&SND_HWDEP_TYPE_SB16CSP);
    eval 'sub SND_HWDEP_TYPE_EMU8000 () {4;}' unless defined(&SND_HWDEP_TYPE_EMU8000);
    eval 'sub SND_HWDEP_TYPE_YSS225 () {5;}' unless defined(&SND_HWDEP_TYPE_YSS225);
    eval 'sub SND_HWDEP_TYPE_ICS2115 () {6;}' unless defined(&SND_HWDEP_TYPE_ICS2115);
    eval 'sub SND_HWDEP_TYPE_LAST () {6;}' unless defined(&SND_HWDEP_TYPE_LAST);
    eval 'sub SND_HWDEP_IOCTL_PVERSION () { &_IOR (ord(\'H\'), 0x00, \'int\');}' unless defined(&SND_HWDEP_IOCTL_PVERSION);
    eval 'sub SND_HWDEP_IOCTL_INFO () { &_IOR (ord(\'H\'), 0x01,  &snd_hwdep_info_t);}' unless defined(&SND_HWDEP_IOCTL_INFO);
    eval 'sub SND_MIXER_VERSION () { &SND_PROTOCOL_VERSION(1, 0, 0);}' unless defined(&SND_MIXER_VERSION);
    eval 'sub SND_MIXER_IN_SYNTHESIZER () {"Synth";}' unless defined(&SND_MIXER_IN_SYNTHESIZER);
    eval 'sub SND_MIXER_IN_PCM () {"PCM";}' unless defined(&SND_MIXER_IN_PCM);
    eval 'sub SND_MIXER_IN_DAC () {"DAC";}' unless defined(&SND_MIXER_IN_DAC);
    eval 'sub SND_MIXER_IN_FM () {"FM";}' unless defined(&SND_MIXER_IN_FM);
    eval 'sub SND_MIXER_IN_DSP () {"DSP Input";}' unless defined(&SND_MIXER_IN_DSP);
    eval 'sub SND_MIXER_IN_LINE () {"Line";}' unless defined(&SND_MIXER_IN_LINE);
    eval 'sub SND_MIXER_IN_MIC () {"MIC";}' unless defined(&SND_MIXER_IN_MIC);
    eval 'sub SND_MIXER_IN_CD () {"CD";}' unless defined(&SND_MIXER_IN_CD);
    eval 'sub SND_MIXER_IN_VIDEO () {"Video";}' unless defined(&SND_MIXER_IN_VIDEO);
    eval 'sub SND_MIXER_IN_RADIO () {"Radio";}' unless defined(&SND_MIXER_IN_RADIO);
    eval 'sub SND_MIXER_IN_PHONE () {"Phone";}' unless defined(&SND_MIXER_IN_PHONE);
    eval 'sub SND_MIXER_IN_MONO () {"Mono";}' unless defined(&SND_MIXER_IN_MONO);
    eval 'sub SND_MIXER_IN_SPEAKER () {"PC Speaker";}' unless defined(&SND_MIXER_IN_SPEAKER);
    eval 'sub SND_MIXER_IN_AUX () {"Aux";}' unless defined(&SND_MIXER_IN_AUX);
    eval 'sub SND_MIXER_IN_CENTER () {"Center Input";}' unless defined(&SND_MIXER_IN_CENTER);
    eval 'sub SND_MIXER_IN_WOOFER () {"Woofer Input";}' unless defined(&SND_MIXER_IN_WOOFER);
    eval 'sub SND_MIXER_IN_SURROUND () {"Surround Input";}' unless defined(&SND_MIXER_IN_SURROUND);
    eval 'sub SND_MIXER_OUT_MASTER () {"Master";}' unless defined(&SND_MIXER_OUT_MASTER);
    eval 'sub SND_MIXER_OUT_MASTER_MONO () {"Master Mono";}' unless defined(&SND_MIXER_OUT_MASTER_MONO);
    eval 'sub SND_MIXER_OUT_MASTER_DIGITAL () {"Master Digital";}' unless defined(&SND_MIXER_OUT_MASTER_DIGITAL);
    eval 'sub SND_MIXER_OUT_HEADPHONE () {"Headphone";}' unless defined(&SND_MIXER_OUT_HEADPHONE);
    eval 'sub SND_MIXER_OUT_PHONE () {"Phone Output";}' unless defined(&SND_MIXER_OUT_PHONE);
    eval 'sub SND_MIXER_OUT_CENTER () {"Center";}' unless defined(&SND_MIXER_OUT_CENTER);
    eval 'sub SND_MIXER_OUT_WOOFER () {"Woofer";}' unless defined(&SND_MIXER_OUT_WOOFER);
    eval 'sub SND_MIXER_OUT_SURROUND () {"Surround";}' unless defined(&SND_MIXER_OUT_SURROUND);
    eval 'sub SND_MIXER_OUT_DSP () {"DSP Output";}' unless defined(&SND_MIXER_OUT_DSP);
    eval 'sub SND_MIXER_GRP_BASS () {"Bass";}' unless defined(&SND_MIXER_GRP_BASS);
    eval 'sub SND_MIXER_GRP_TREBLE () {"Treble";}' unless defined(&SND_MIXER_GRP_TREBLE);
    eval 'sub SND_MIXER_GRP_EQUALIZER () {"Equalizer";}' unless defined(&SND_MIXER_GRP_EQUALIZER);
    eval 'sub SND_MIXER_GRP_FADER () {"Fader";}' unless defined(&SND_MIXER_GRP_FADER);
    eval 'sub SND_MIXER_GRP_EFFECT () {"Effect";}' unless defined(&SND_MIXER_GRP_EFFECT);
    eval 'sub SND_MIXER_GRP_EFFECT_3D () {"3D Effect";}' unless defined(&SND_MIXER_GRP_EFFECT_3D);
    eval 'sub SND_MIXER_GRP_MIC_GAIN () {"Mic Gain";}' unless defined(&SND_MIXER_GRP_MIC_GAIN);
    eval 'sub SND_MIXER_GRP_IGAIN () {"Input Gain";}' unless defined(&SND_MIXER_GRP_IGAIN);
    eval 'sub SND_MIXER_GRP_OGAIN () {"Output Gain";}' unless defined(&SND_MIXER_GRP_OGAIN);
    eval 'sub SND_MIXER_GRP_ANALOG_LOOPBACK () {"Analog Loopback";}' unless defined(&SND_MIXER_GRP_ANALOG_LOOPBACK);
    eval 'sub SND_MIXER_GRP_DIGITAL_LOOPBACK () {"Digital Loopback";}' unless defined(&SND_MIXER_GRP_DIGITAL_LOOPBACK);
    eval 'sub SND_MIXER_ELEMENT_TONE_CONTROL () {"Tone Control";}' unless defined(&SND_MIXER_ELEMENT_TONE_CONTROL);
    eval 'sub SND_MIXER_ELEMENT_INPUT_MUX () {"Input MUX";}' unless defined(&SND_MIXER_ELEMENT_INPUT_MUX);
    eval 'sub SND_MIXER_ELEMENT_DIGITAL_ACCU () {"Digital Accumulator";}' unless defined(&SND_MIXER_ELEMENT_DIGITAL_ACCU);
    eval 'sub SND_MIXER_ELEMENT_OUTPUT_ACCU () {"Output Accumulator";}' unless defined(&SND_MIXER_ELEMENT_OUTPUT_ACCU);
    eval 'sub SND_MIXER_ELEMENT_INPUT_ACCU () {"Input Accumulator";}' unless defined(&SND_MIXER_ELEMENT_INPUT_ACCU);
    eval 'sub SND_MIXER_ELEMENT_MONO_OUT_ACCU () {"Mono-Out Accumulator";}' unless defined(&SND_MIXER_ELEMENT_MONO_OUT_ACCU);
    eval 'sub SND_MIXER_ELEMENT_MONO_IN_ACCU () {"Mono-In Accumulator";}' unless defined(&SND_MIXER_ELEMENT_MONO_IN_ACCU);
    eval 'sub SND_MIXER_ELEMENT_DAC () {"Digital-Analog Converter";}' unless defined(&SND_MIXER_ELEMENT_DAC);
    eval 'sub SND_MIXER_ELEMENT_ADC () {"Analog-Digital Converter";}' unless defined(&SND_MIXER_ELEMENT_ADC);
    eval 'sub SND_MIXER_ELEMENT_CAPTURE () {"Capture";}' unless defined(&SND_MIXER_ELEMENT_CAPTURE);
    eval 'sub SND_MIXER_ELEMENT_PLAYBACK () {"Playback";}' unless defined(&SND_MIXER_ELEMENT_PLAYBACK);
    eval 'sub SND_MIXER_SW_IEC958_OUTPUT () {"IEC-958 (S/PDIF) Output";}' unless defined(&SND_MIXER_SW_IEC958_OUTPUT);
    eval 'sub SND_MIXER_SW_IEC958_INPUT () {"IEC-958 (S/PDIF) Input";}' unless defined(&SND_MIXER_SW_IEC958_INPUT);
    eval 'sub SND_MIXER_SW_SIM_STEREO () {"Simulated Stereo Enhancement";}' unless defined(&SND_MIXER_SW_SIM_STEREO);
    eval 'sub SND_MIXER_SW_LOUDNESS () {"Loudness (bass boost)";}' unless defined(&SND_MIXER_SW_LOUDNESS);
    eval 'sub SND_MIXER_ETYPE_INPUT () {0;}' unless defined(&SND_MIXER_ETYPE_INPUT);
    eval 'sub SND_MIXER_ETYPE_OUTPUT () {1;}' unless defined(&SND_MIXER_ETYPE_OUTPUT);
    eval 'sub SND_MIXER_ETYPE_CAPTURE1 () {2;}' unless defined(&SND_MIXER_ETYPE_CAPTURE1);
    eval 'sub SND_MIXER_ETYPE_CAPTURE2 () {3;}' unless defined(&SND_MIXER_ETYPE_CAPTURE2);
    eval 'sub SND_MIXER_ETYPE_PLAYBACK1 () {4;}' unless defined(&SND_MIXER_ETYPE_PLAYBACK1);
    eval 'sub SND_MIXER_ETYPE_PLAYBACK2 () {5;}' unless defined(&SND_MIXER_ETYPE_PLAYBACK2);
    eval 'sub SND_MIXER_ETYPE_ADC () {6;}' unless defined(&SND_MIXER_ETYPE_ADC);
    eval 'sub SND_MIXER_ETYPE_DAC () {7;}' unless defined(&SND_MIXER_ETYPE_DAC);
    eval 'sub SND_MIXER_ETYPE_SWITCH1 () {100;}' unless defined(&SND_MIXER_ETYPE_SWITCH1);
    eval 'sub SND_MIXER_ETYPE_SWITCH2 () {101;}' unless defined(&SND_MIXER_ETYPE_SWITCH2);
    eval 'sub SND_MIXER_ETYPE_SWITCH3 () {102;}' unless defined(&SND_MIXER_ETYPE_SWITCH3);
    eval 'sub SND_MIXER_ETYPE_VOLUME1 () {200;}' unless defined(&SND_MIXER_ETYPE_VOLUME1);
    eval 'sub SND_MIXER_ETYPE_VOLUME2 () {201;}' unless defined(&SND_MIXER_ETYPE_VOLUME2);
    eval 'sub SND_MIXER_ETYPE_ACCU1 () {300;}' unless defined(&SND_MIXER_ETYPE_ACCU1);
    eval 'sub SND_MIXER_ETYPE_ACCU2 () {301;}' unless defined(&SND_MIXER_ETYPE_ACCU2);
    eval 'sub SND_MIXER_ETYPE_ACCU3 () {302;}' unless defined(&SND_MIXER_ETYPE_ACCU3);
    eval 'sub SND_MIXER_ETYPE_MUX1 () {400;}' unless defined(&SND_MIXER_ETYPE_MUX1);
    eval 'sub SND_MIXER_ETYPE_MUX2 () {401;}' unless defined(&SND_MIXER_ETYPE_MUX2);
    eval 'sub SND_MIXER_ETYPE_TONE_CONTROL1 () {500;}' unless defined(&SND_MIXER_ETYPE_TONE_CONTROL1);
    eval 'sub SND_MIXER_ETYPE_EQUALIZER1 () {501;}' unless defined(&SND_MIXER_ETYPE_EQUALIZER1);
    eval 'sub SND_MIXER_ETYPE_PAN_CONTROL1 () {502;}' unless defined(&SND_MIXER_ETYPE_PAN_CONTROL1);
    eval 'sub SND_MIXER_ETYPE_3D_EFFECT1 () {600;}' unless defined(&SND_MIXER_ETYPE_3D_EFFECT1);
    eval 'sub SND_MIXER_ETYPE_PRE_EFFECT1 () {610;}' unless defined(&SND_MIXER_ETYPE_PRE_EFFECT1);
    eval 'sub SND_MIXER_VOICE_UNUSED () {0;}' unless defined(&SND_MIXER_VOICE_UNUSED);
    eval 'sub SND_MIXER_VOICE_MONO () {1;}' unless defined(&SND_MIXER_VOICE_MONO);
    eval 'sub SND_MIXER_VOICE_LEFT () {2;}' unless defined(&SND_MIXER_VOICE_LEFT);
    eval 'sub SND_MIXER_VOICE_RIGHT () {3;}' unless defined(&SND_MIXER_VOICE_RIGHT);
    eval 'sub SND_MIXER_VOICE_CENTER () {4;}' unless defined(&SND_MIXER_VOICE_CENTER);
    eval 'sub SND_MIXER_VOICE_REAR_LEFT () {5;}' unless defined(&SND_MIXER_VOICE_REAR_LEFT);
    eval 'sub SND_MIXER_VOICE_REAR_RIGHT () {6;}' unless defined(&SND_MIXER_VOICE_REAR_RIGHT);
    eval 'sub SND_MIXER_VOICE_WOOFER () {7;}' unless defined(&SND_MIXER_VOICE_WOOFER);
    eval("sub SND_MIXER_CHN_FRONT_LEFT () { 0; }") unless defined(&SND_MIXER_CHN_FRONT_LEFT);
    eval("sub SND_MIXER_CHN_FRONT_RIGHT () { 1; }") unless defined(&SND_MIXER_CHN_FRONT_RIGHT);
    eval("sub SND_MIXER_CHN_FRONT_CENTER () { 2; }") unless defined(&SND_MIXER_CHN_FRONT_CENTER);
    eval("sub SND_MIXER_CHN_REAR_LEFT () { 3; }") unless defined(&SND_MIXER_CHN_REAR_LEFT);
    eval("sub SND_MIXER_CHN_REAR_RIGHT () { 4; }") unless defined(&SND_MIXER_CHN_REAR_RIGHT);
    eval("sub SND_MIXER_CHN_WOOFER () { 5; }") unless defined(&SND_MIXER_CHN_WOOFER);
    eval("sub SND_MIXER_CHN_LAST () { 31; }") unless defined(&SND_MIXER_CHN_LAST);
    eval("sub SND_MIXER_CHN_MONO () { SND_MIXER_CHN_FRONT_LEFT; }") unless defined(&SND_MIXER_CHN_MONO);
    eval 'sub SND_MIXER_CHN_MASK_MONO () {(1<< &SND_MIXER_CHN_MONO);}' unless defined(&SND_MIXER_CHN_MASK_MONO);
    eval 'sub SND_MIXER_CHN_MASK_FRONT_LEFT () {(1<< &SND_MIXER_CHN_FRONT_LEFT);}' unless defined(&SND_MIXER_CHN_MASK_FRONT_LEFT);
    eval 'sub SND_MIXER_CHN_MASK_FRONT_RIGHT () {(1<< &SND_MIXER_CHN_FRONT_RIGHT);}' unless defined(&SND_MIXER_CHN_MASK_FRONT_RIGHT);
    eval 'sub SND_MIXER_CHN_MASK_FRONT_CENTER () {(1<< &SND_MIXER_CHN_FRONT_CENTER);}' unless defined(&SND_MIXER_CHN_MASK_FRONT_CENTER);
    eval 'sub SND_MIXER_CHN_MASK_REAR_LEFT () {(1<< &SND_MIXER_CHN_REAR_LEFT);}' unless defined(&SND_MIXER_CHN_MASK_REAR_LEFT);
    eval 'sub SND_MIXER_CHN_MASK_REAR_RIGHT () {(1<< &SND_MIXER_CHN_REAR_RIGHT);}' unless defined(&SND_MIXER_CHN_MASK_REAR_RIGHT);
    eval 'sub SND_MIXER_CHN_MASK_WOOFER () {(1<< &SND_MIXER_CHN_WOOFER);}' unless defined(&SND_MIXER_CHN_MASK_WOOFER);
    eval 'sub SND_MIXER_CHN_MASK_STEREO () {( &SND_MIXER_CHN_MASK_FRONT_LEFT| &SND_MIXER_CHN_MASK_FRONT_RIGHT);}' unless defined(&SND_MIXER_CHN_MASK_STEREO);
    eval 'sub SND_MIXER_GRPCAP_VOLUME () {(1<<0);}' unless defined(&SND_MIXER_GRPCAP_VOLUME);
    eval 'sub SND_MIXER_GRPCAP_JOINTLY_VOLUME () {(1<<1);}' unless defined(&SND_MIXER_GRPCAP_JOINTLY_VOLUME);
    eval 'sub SND_MIXER_GRPCAP_MUTE () {(1<<2);}' unless defined(&SND_MIXER_GRPCAP_MUTE);
    eval 'sub SND_MIXER_GRPCAP_JOINTLY_MUTE () {(1<<3);}' unless defined(&SND_MIXER_GRPCAP_JOINTLY_MUTE);
    eval 'sub SND_MIXER_GRPCAP_CAPTURE () {(1<<4);}' unless defined(&SND_MIXER_GRPCAP_CAPTURE);
    eval 'sub SND_MIXER_GRPCAP_JOINTLY_CAPTURE () {(1<<5);}' unless defined(&SND_MIXER_GRPCAP_JOINTLY_CAPTURE);
    eval 'sub SND_MIXER_GRPCAP_EXCL_CAPTURE () {(1<<6);}' unless defined(&SND_MIXER_GRPCAP_EXCL_CAPTURE);
    eval 'sub SND_MIXER_EIO_DIGITAL () {(0<<1);}' unless defined(&SND_MIXER_EIO_DIGITAL);
    eval 'sub SND_MIXER_SWITCH3_FULL_FEATURED () {0;}' unless defined(&SND_MIXER_SWITCH3_FULL_FEATURED);
    eval 'sub SND_MIXER_SWITCH3_ALWAYS_DESTINATION () {1;}' unless defined(&SND_MIXER_SWITCH3_ALWAYS_DESTINATION);
    eval 'sub SND_MIXER_SWITCH3_ONE_DESTINATION () {2;}' unless defined(&SND_MIXER_SWITCH3_ONE_DESTINATION);
    eval 'sub SND_MIXER_SWITCH3_ALWAYS_ONE_DESTINATION () {3;}' unless defined(&SND_MIXER_SWITCH3_ALWAYS_ONE_DESTINATION);
    eval 'sub SND_MIXER_MUX1_NONE () {(1<<0);}' unless defined(&SND_MIXER_MUX1_NONE);
    eval 'sub SND_MIXER_MUX2_NONE () {(1<<0);}' unless defined(&SND_MIXER_MUX2_NONE);
    eval 'sub SND_MIXER_TC1_SW () {(1<<0);}' unless defined(&SND_MIXER_TC1_SW);
    eval 'sub SND_MIXER_TC1_BASS () {(1<<1);}' unless defined(&SND_MIXER_TC1_BASS);
    eval 'sub SND_MIXER_TC1_TREBLE () {(1<<2);}' unless defined(&SND_MIXER_TC1_TREBLE);
    eval 'sub SND_MIXER_PAN_LEFT_RIGHT () {0;}' unless defined(&SND_MIXER_PAN_LEFT_RIGHT);
    eval 'sub SND_MIXER_PAN_FRONT_REAR () {1;}' unless defined(&SND_MIXER_PAN_FRONT_REAR);
    eval 'sub SND_MIXER_PAN_BOTTOM_UP () {2;}' unless defined(&SND_MIXER_PAN_BOTTOM_UP);
    eval 'sub SND_MIXER_EFF1_SW () {(1<<0);}' unless defined(&SND_MIXER_EFF1_SW);
    eval 'sub SND_MIXER_EFF1_MONO_SW () {(1<<1);}' unless defined(&SND_MIXER_EFF1_MONO_SW);
    eval 'sub SND_MIXER_EFF1_WIDE () {(1<<2);}' unless defined(&SND_MIXER_EFF1_WIDE);
    eval 'sub SND_MIXER_EFF1_VOLUME () {(1<<3);}' unless defined(&SND_MIXER_EFF1_VOLUME);
    eval 'sub SND_MIXER_EFF1_CENTER () {(1<<4);}' unless defined(&SND_MIXER_EFF1_CENTER);
    eval 'sub SND_MIXER_EFF1_SPACE () {(1<<5);}' unless defined(&SND_MIXER_EFF1_SPACE);
    eval 'sub SND_MIXER_EFF1_DEPTH () {(1<<6);}' unless defined(&SND_MIXER_EFF1_DEPTH);
    eval 'sub SND_MIXER_EFF1_DELAY () {(1<<7);}' unless defined(&SND_MIXER_EFF1_DELAY);
    eval 'sub SND_MIXER_EFF1_FEEDBACK () {(1<<8);}' unless defined(&SND_MIXER_EFF1_FEEDBACK);
    eval 'sub SND_MIXER_EFF1_DEPTH_REAR () {(1<<9);}' unless defined(&SND_MIXER_EFF1_DEPTH_REAR);
    eval 'sub SND_MIXER_IOCTL_PVERSION () { &_IOR (ord(\'R\'), 0x00, \'int\');}' unless defined(&SND_MIXER_IOCTL_PVERSION);
    eval 'sub SND_MIXER_IOCTL_INFO () { &_IOR (ord(\'R\'), 0x01,  &snd_mixer_info_t);}' unless defined(&SND_MIXER_IOCTL_INFO);
    eval 'sub SND_MIXER_IOCTL_ELEMENTS () { &_IOWR(ord(\'R\'), 0x10,  &snd_mixer_elements_t);}' unless defined(&SND_MIXER_IOCTL_ELEMENTS);
    eval 'sub SND_MIXER_IOCTL_ROUTES () { &_IOWR(ord(\'R\'), 0x11,  &snd_mixer_routes_t);}' unless defined(&SND_MIXER_IOCTL_ROUTES);
    eval 'sub SND_MIXER_IOCTL_GROUPS () { &_IOWR(ord(\'R\'), 0x12,  &snd_mixer_groups_t);}' unless defined(&SND_MIXER_IOCTL_GROUPS);
    eval 'sub SND_MIXER_IOCTL_GROUP_READ () { &_IOWR(ord(\'R\'), 0x13,  &snd_mixer_group_t);}' unless defined(&SND_MIXER_IOCTL_GROUP_READ);
    eval 'sub SND_MIXER_IOCTL_GROUP_WRITE () { &_IOWR(ord(\'R\'), 0x14,  &snd_mixer_group_t);}' unless defined(&SND_MIXER_IOCTL_GROUP_WRITE);
    eval 'sub SND_MIXER_IOCTL_ELEMENT_INFO () { &_IOWR(ord(\'R\'), 0x20,  &snd_mixer_element_info_t);}' unless defined(&SND_MIXER_IOCTL_ELEMENT_INFO);
    eval 'sub SND_MIXER_IOCTL_ELEMENT_READ () { &_IOWR(ord(\'R\'), 0x21,  &snd_mixer_element_t);}' unless defined(&SND_MIXER_IOCTL_ELEMENT_READ);
    eval 'sub SND_MIXER_IOCTL_ELEMENT_WRITE () { &_IOWR(ord(\'R\'), 0x22,  &snd_mixer_element_t);}' unless defined(&SND_MIXER_IOCTL_ELEMENT_WRITE);
    eval 'sub SND_MIXER_IOCTL_GET_FILTER () { &_IOR (ord(\'R\'), 0x30,  &snd_mixer_filter_t);}' unless defined(&SND_MIXER_IOCTL_GET_FILTER);
    eval 'sub SND_MIXER_IOCTL_PUT_FILTER () { &_IOW (ord(\'R\'), 0x30,  &snd_mixer_filter_t);}' unless defined(&SND_MIXER_IOCTL_PUT_FILTER);
    eval 'sub SND_MIXER_READ_REBUILD () {0;}' unless defined(&SND_MIXER_READ_REBUILD);
    eval 'sub SND_MIXER_READ_ELEMENT_VALUE () {1;}' unless defined(&SND_MIXER_READ_ELEMENT_VALUE);
    eval 'sub SND_MIXER_READ_ELEMENT_CHANGE () {2;}' unless defined(&SND_MIXER_READ_ELEMENT_CHANGE);
    eval 'sub SND_MIXER_READ_ELEMENT_ROUTE () {3;}' unless defined(&SND_MIXER_READ_ELEMENT_ROUTE);
    eval 'sub SND_MIXER_READ_ELEMENT_ADD () {4;}' unless defined(&SND_MIXER_READ_ELEMENT_ADD);
    eval 'sub SND_MIXER_READ_ELEMENT_REMOVE () {5;}' unless defined(&SND_MIXER_READ_ELEMENT_REMOVE);
    eval 'sub SND_MIXER_READ_GROUP_VALUE () {6;}' unless defined(&SND_MIXER_READ_GROUP_VALUE);
    eval 'sub SND_MIXER_READ_GROUP_CHANGE () {7;}' unless defined(&SND_MIXER_READ_GROUP_CHANGE);
    eval 'sub SND_MIXER_READ_GROUP_ADD () {8;}' unless defined(&SND_MIXER_READ_GROUP_ADD);
    eval 'sub SND_MIXER_READ_GROUP_REMOVE () {9;}' unless defined(&SND_MIXER_READ_GROUP_REMOVE);
    if(defined(&__SND_OSS_COMPAT__)) {
	eval 'sub SND_MIXER_OSS_CAP_EXCL_INPUT () {0x00000001;}' unless defined(&SND_MIXER_OSS_CAP_EXCL_INPUT);
	eval 'sub SND_MIXER_OSS_DEVS () {25;}' unless defined(&SND_MIXER_OSS_DEVS);
	eval 'sub SND_MIXER_OSS_VOLUME () {0;}' unless defined(&SND_MIXER_OSS_VOLUME);
	eval 'sub SND_MIXER_OSS_BASS () {1;}' unless defined(&SND_MIXER_OSS_BASS);
	eval 'sub SND_MIXER_OSS_TREBLE () {2;}' unless defined(&SND_MIXER_OSS_TREBLE);
	eval 'sub SND_MIXER_OSS_SYNTH () {3;}' unless defined(&SND_MIXER_OSS_SYNTH);
	eval 'sub SND_MIXER_OSS_PCM () {4;}' unless defined(&SND_MIXER_OSS_PCM);
	eval 'sub SND_MIXER_OSS_SPEAKER () {5;}' unless defined(&SND_MIXER_OSS_SPEAKER);
	eval 'sub SND_MIXER_OSS_LINE () {6;}' unless defined(&SND_MIXER_OSS_LINE);
	eval 'sub SND_MIXER_OSS_MIC () {7;}' unless defined(&SND_MIXER_OSS_MIC);
	eval 'sub SND_MIXER_OSS_CD () {8;}' unless defined(&SND_MIXER_OSS_CD);
	eval 'sub SND_MIXER_OSS_IMIX () {9;}' unless defined(&SND_MIXER_OSS_IMIX);
	eval 'sub SND_MIXER_OSS_ALTPCM () {10;}' unless defined(&SND_MIXER_OSS_ALTPCM);
	eval 'sub SND_MIXER_OSS_RECLEV () {11;}' unless defined(&SND_MIXER_OSS_RECLEV);
	eval 'sub SND_MIXER_OSS_IGAIN () {12;}' unless defined(&SND_MIXER_OSS_IGAIN);
	eval 'sub SND_MIXER_OSS_OGAIN () {13;}' unless defined(&SND_MIXER_OSS_OGAIN);
	eval 'sub SND_MIXER_OSS_LINE1 () {14;}' unless defined(&SND_MIXER_OSS_LINE1);
	eval 'sub SND_MIXER_OSS_LINE2 () {15;}' unless defined(&SND_MIXER_OSS_LINE2);
	eval 'sub SND_MIXER_OSS_LINE3 () {16;}' unless defined(&SND_MIXER_OSS_LINE3);
	eval 'sub SND_MIXER_OSS_DIGITAL1 () {17;}' unless defined(&SND_MIXER_OSS_DIGITAL1);
	eval 'sub SND_MIXER_OSS_DIGITAL2 () {18;}' unless defined(&SND_MIXER_OSS_DIGITAL2);
	eval 'sub SND_MIXER_OSS_DIGITAL3 () {19;}' unless defined(&SND_MIXER_OSS_DIGITAL3);
	eval 'sub SND_MIXER_OSS_PHONEIN () {20;}' unless defined(&SND_MIXER_OSS_PHONEIN);
	eval 'sub SND_MIXER_OSS_PHONEOUT () {21;}' unless defined(&SND_MIXER_OSS_PHONEOUT);
	eval 'sub SND_MIXER_OSS_VIDEO () {22;}' unless defined(&SND_MIXER_OSS_VIDEO);
	eval 'sub SND_MIXER_OSS_RADIO () {23;}' unless defined(&SND_MIXER_OSS_RADIO);
	eval 'sub SND_MIXER_OSS_MONITOR () {24;}' unless defined(&SND_MIXER_OSS_MONITOR);
	eval 'sub SND_MIXER_OSS_UNKNOWN () {(32+1);}' unless defined(&SND_MIXER_OSS_UNKNOWN);
	eval 'sub SND_MIXER_OSS_SET_RECSRC () { &_IOWR(ord(\'M\'), 255, \'int\');}' unless defined(&SND_MIXER_OSS_SET_RECSRC);
	eval 'sub SND_MIXER_OSS_RECSRC () { &_IOR (ord(\'M\'), 255, \'int\');}' unless defined(&SND_MIXER_OSS_RECSRC);
	eval 'sub SND_MIXER_OSS_DEVMASK () { &_IOR (ord(\'M\'), 254, \'int\');}' unless defined(&SND_MIXER_OSS_DEVMASK);
	eval 'sub SND_MIXER_OSS_RECMASK () { &_IOR (ord(\'M\'), 253, \'int\');}' unless defined(&SND_MIXER_OSS_RECMASK);
	eval 'sub SND_MIXER_OSS_CAPS () { &_IOR (ord(\'M\'), 252, \'int\');}' unless defined(&SND_MIXER_OSS_CAPS);
	eval 'sub SND_MIXER_OSS_STEREODEVS () { &_IOR (ord(\'M\'), 251, \'int\');}' unless defined(&SND_MIXER_OSS_STEREODEVS);
	eval 'sub SND_MIXER_OSS_INFO () { &_IOR (ord(\'M\'), 101, \'struct snd_oss_mixer_info\');}' unless defined(&SND_MIXER_OSS_INFO);
	eval 'sub SND_MIXER_OSS_OLD_INFO () { &_IOR (ord(\'M\'), 101, \'struct snd_oss_mixer_info_obsolete\');}' unless defined(&SND_MIXER_OSS_OLD_INFO);
	eval 'sub SND_OSS_GETVERSION () { &_IOR (ord(\'M\'), 118, \'int\');}' unless defined(&SND_OSS_GETVERSION);
    }
    eval 'sub SND_PCM_VERSION () { &SND_PROTOCOL_VERSION(1, 0, 0);}' unless defined(&SND_PCM_VERSION);
    eval 'sub SND_PCM_CHANNEL_PLAYBACK () {0;}' unless defined(&SND_PCM_CHANNEL_PLAYBACK);
    eval 'sub SND_PCM_CHANNEL_CAPTURE () {1;}' unless defined(&SND_PCM_CHANNEL_CAPTURE);
    eval 'sub SND_PCM_MODE_UNKNOWN () {(-1);}' unless defined(&SND_PCM_MODE_UNKNOWN);
    eval 'sub SND_PCM_MODE_STREAM () {0;}' unless defined(&SND_PCM_MODE_STREAM);
    eval 'sub SND_PCM_MODE_BLOCK () {1;}' unless defined(&SND_PCM_MODE_BLOCK);
    eval 'sub SND_PCM_SFMT_S8 () {0;}' unless defined(&SND_PCM_SFMT_S8);
    eval 'sub SND_PCM_SFMT_U8 () {1;}' unless defined(&SND_PCM_SFMT_U8);
    eval 'sub SND_PCM_SFMT_S16_LE () {2;}' unless defined(&SND_PCM_SFMT_S16_LE);
    eval 'sub SND_PCM_SFMT_S16_BE () {3;}' unless defined(&SND_PCM_SFMT_S16_BE);
    eval 'sub SND_PCM_SFMT_U16_LE () {4;}' unless defined(&SND_PCM_SFMT_U16_LE);
    eval 'sub SND_PCM_SFMT_U16_BE () {5;}' unless defined(&SND_PCM_SFMT_U16_BE);
    eval 'sub SND_PCM_SFMT_S24_LE () {6;}' unless defined(&SND_PCM_SFMT_S24_LE);
    eval 'sub SND_PCM_SFMT_S24_BE () {7;}' unless defined(&SND_PCM_SFMT_S24_BE);
    eval 'sub SND_PCM_SFMT_U24_LE () {8;}' unless defined(&SND_PCM_SFMT_U24_LE);
    eval 'sub SND_PCM_SFMT_U24_BE () {9;}' unless defined(&SND_PCM_SFMT_U24_BE);
    eval 'sub SND_PCM_SFMT_S32_LE () {10;}' unless defined(&SND_PCM_SFMT_S32_LE);
    eval 'sub SND_PCM_SFMT_S32_BE () {11;}' unless defined(&SND_PCM_SFMT_S32_BE);
    eval 'sub SND_PCM_SFMT_U32_LE () {12;}' unless defined(&SND_PCM_SFMT_U32_LE);
    eval 'sub SND_PCM_SFMT_U32_BE () {13;}' unless defined(&SND_PCM_SFMT_U32_BE);
    eval 'sub SND_PCM_SFMT_FLOAT_LE () {14;}' unless defined(&SND_PCM_SFMT_FLOAT_LE);
    eval 'sub SND_PCM_SFMT_FLOAT_BE () {15;}' unless defined(&SND_PCM_SFMT_FLOAT_BE);
    eval 'sub SND_PCM_SFMT_FLOAT64_LE () {16;}' unless defined(&SND_PCM_SFMT_FLOAT64_LE);
    eval 'sub SND_PCM_SFMT_FLOAT64_BE () {17;}' unless defined(&SND_PCM_SFMT_FLOAT64_BE);
    eval 'sub SND_PCM_SFMT_IEC958_SUBFRAME_LE () {18;}' unless defined(&SND_PCM_SFMT_IEC958_SUBFRAME_LE);
    eval 'sub SND_PCM_SFMT_IEC958_SUBFRAME_BE () {19;}' unless defined(&SND_PCM_SFMT_IEC958_SUBFRAME_BE);
    eval 'sub SND_PCM_SFMT_MU_LAW () {20;}' unless defined(&SND_PCM_SFMT_MU_LAW);
    eval 'sub SND_PCM_SFMT_A_LAW () {21;}' unless defined(&SND_PCM_SFMT_A_LAW);
    eval 'sub SND_PCM_SFMT_IMA_ADPCM () {22;}' unless defined(&SND_PCM_SFMT_IMA_ADPCM);
    eval 'sub SND_PCM_SFMT_MPEG () {23;}' unless defined(&SND_PCM_SFMT_MPEG);
    eval 'sub SND_PCM_SFMT_GSM () {24;}' unless defined(&SND_PCM_SFMT_GSM);
    eval 'sub SND_PCM_SFMT_SPECIAL () {31;}' unless defined(&SND_PCM_SFMT_SPECIAL);
    if(defined(&SND_LITTLE_ENDIAN)) {
	eval 'sub SND_PCM_SFMT_S16 () { &SND_PCM_SFMT_S16_LE;}' unless defined(&SND_PCM_SFMT_S16);
	eval 'sub SND_PCM_SFMT_U16 () { &SND_PCM_SFMT_U16_LE;}' unless defined(&SND_PCM_SFMT_U16);
	eval 'sub SND_PCM_SFMT_S24 () { &SND_PCM_SFMT_S24_LE;}' unless defined(&SND_PCM_SFMT_S24);
	eval 'sub SND_PCM_SFMT_U24 () { &SND_PCM_SFMT_U24_LE;}' unless defined(&SND_PCM_SFMT_U24);
	eval 'sub SND_PCM_SFMT_S32 () { &SND_PCM_SFMT_S32_LE;}' unless defined(&SND_PCM_SFMT_S32);
	eval 'sub SND_PCM_SFMT_U32 () { &SND_PCM_SFMT_U32_LE;}' unless defined(&SND_PCM_SFMT_U32);
	eval 'sub SND_PCM_SFMT_FLOAT () { &SND_PCM_SFMT_FLOAT_LE;}' unless defined(&SND_PCM_SFMT_FLOAT);
	eval 'sub SND_PCM_SFMT_FLOAT64 () { &SND_PCM_SFMT_FLOAT64_LE;}' unless defined(&SND_PCM_SFMT_FLOAT64);
	eval 'sub SND_PCM_SFMT_IEC958_SUBFRAME () { &SND_PCM_SFMT_IEC958_SUBFRAME_LE;}' unless defined(&SND_PCM_SFMT_IEC958_SUBFRAME);
    }
    if(defined(&SND_BIG_ENDIAN)) {
	eval 'sub SND_PCM_SFMT_S16 () { &SND_PCM_SFMT_S16_BE;}' unless defined(&SND_PCM_SFMT_S16);
	eval 'sub SND_PCM_SFMT_U16 () { &SND_PCM_SFMT_U16_BE;}' unless defined(&SND_PCM_SFMT_U16);
	eval 'sub SND_PCM_SFMT_S24 () { &SND_PCM_SFMT_S24_BE;}' unless defined(&SND_PCM_SFMT_S24);
	eval 'sub SND_PCM_SFMT_U24 () { &SND_PCM_SFMT_U24_BE;}' unless defined(&SND_PCM_SFMT_U24);
	eval 'sub SND_PCM_SFMT_S32 () { &SND_PCM_SFMT_S32_BE;}' unless defined(&SND_PCM_SFMT_S32);
	eval 'sub SND_PCM_SFMT_U32 () { &SND_PCM_SFMT_U32_BE;}' unless defined(&SND_PCM_SFMT_U32);
	eval 'sub SND_PCM_SFMT_FLOAT () { &SND_PCM_SFMT_FLOAT_BE;}' unless defined(&SND_PCM_SFMT_FLOAT);
	eval 'sub SND_PCM_SFMT_FLOAT64 () { &SND_PCM_SFMT_FLOAT64_BE;}' unless defined(&SND_PCM_SFMT_FLOAT64);
	eval 'sub SND_PCM_SFMT_IEC958_SUBFRAME () { &SND_PCM_SFMT_IEC958_SUBFRAME_BE;}' unless defined(&SND_PCM_SFMT_IEC958_SUBFRAME);
    }
    eval 'sub SND_PCM_FMT_S8 () {(1<<  &SND_PCM_SFMT_S8);}' unless defined(&SND_PCM_FMT_S8);
    eval 'sub SND_PCM_FMT_U8 () {(1<<  &SND_PCM_SFMT_U8);}' unless defined(&SND_PCM_FMT_U8);
    eval 'sub SND_PCM_FMT_S16_LE () {(1<<  &SND_PCM_SFMT_S16_LE);}' unless defined(&SND_PCM_FMT_S16_LE);
    eval 'sub SND_PCM_FMT_S16_BE () {(1<<  &SND_PCM_SFMT_S16_BE);}' unless defined(&SND_PCM_FMT_S16_BE);
    eval 'sub SND_PCM_FMT_U16_LE () {(1<<  &SND_PCM_SFMT_U16_LE);}' unless defined(&SND_PCM_FMT_U16_LE);
    eval 'sub SND_PCM_FMT_U16_BE () {(1<<  &SND_PCM_SFMT_U16_BE);}' unless defined(&SND_PCM_FMT_U16_BE);
    eval 'sub SND_PCM_FMT_S24_LE () {(1<<  &SND_PCM_SFMT_S24_LE);}' unless defined(&SND_PCM_FMT_S24_LE);
    eval 'sub SND_PCM_FMT_S24_BE () {(1<<  &SND_PCM_SFMT_S24_BE);}' unless defined(&SND_PCM_FMT_S24_BE);
    eval 'sub SND_PCM_FMT_U24_LE () {(1<<  &SND_PCM_SFMT_U24_LE);}' unless defined(&SND_PCM_FMT_U24_LE);
    eval 'sub SND_PCM_FMT_U24_BE () {(1<<  &SND_PCM_SFMT_U24_BE);}' unless defined(&SND_PCM_FMT_U24_BE);
    eval 'sub SND_PCM_FMT_S32_LE () {(1<<  &SND_PCM_SFMT_S32_LE);}' unless defined(&SND_PCM_FMT_S32_LE);
    eval 'sub SND_PCM_FMT_S32_BE () {(1<<  &SND_PCM_SFMT_S32_BE);}' unless defined(&SND_PCM_FMT_S32_BE);
    eval 'sub SND_PCM_FMT_U32_LE () {(1<<  &SND_PCM_SFMT_U32_LE);}' unless defined(&SND_PCM_FMT_U32_LE);
    eval 'sub SND_PCM_FMT_U32_BE () {(1<<  &SND_PCM_SFMT_U32_BE);}' unless defined(&SND_PCM_FMT_U32_BE);
    eval 'sub SND_PCM_FMT_FLOAT_LE () {(1<<  &SND_PCM_SFMT_FLOAT_LE);}' unless defined(&SND_PCM_FMT_FLOAT_LE);
    eval 'sub SND_PCM_FMT_FLOAT_BE () {(1<<  &SND_PCM_SFMT_FLOAT_BE);}' unless defined(&SND_PCM_FMT_FLOAT_BE);
    eval 'sub SND_PCM_FMT_FLOAT64_LE () {(1<<  &SND_PCM_SFMT_FLOAT64_LE);}' unless defined(&SND_PCM_FMT_FLOAT64_LE);
    eval 'sub SND_PCM_FMT_FLOAT64_BE () {(1<<  &SND_PCM_SFMT_FLOAT64_BE);}' unless defined(&SND_PCM_FMT_FLOAT64_BE);
    eval 'sub SND_PCM_FMT_IEC958_SUBFRAME_LE () {(1<<  &SND_PCM_SFMT_IEC958_SUBFRAME_LE);}' unless defined(&SND_PCM_FMT_IEC958_SUBFRAME_LE);
    eval 'sub SND_PCM_FMT_IEC958_SUBFRAME_BE () {(1<<  &SND_PCM_SFMT_IEC958_SUBFRAME_BE);}' unless defined(&SND_PCM_FMT_IEC958_SUBFRAME_BE);
    eval 'sub SND_PCM_FMT_MU_LAW () {(1<<  &SND_PCM_SFMT_MU_LAW);}' unless defined(&SND_PCM_FMT_MU_LAW);
    eval 'sub SND_PCM_FMT_A_LAW () {(1<<  &SND_PCM_SFMT_A_LAW);}' unless defined(&SND_PCM_FMT_A_LAW);
    eval 'sub SND_PCM_FMT_IMA_ADPCM () {(1<<  &SND_PCM_SFMT_IMA_ADPCM);}' unless defined(&SND_PCM_FMT_IMA_ADPCM);
    eval 'sub SND_PCM_FMT_MPEG () {(1<<  &SND_PCM_SFMT_MPEG);}' unless defined(&SND_PCM_FMT_MPEG);
    eval 'sub SND_PCM_FMT_GSM () {(1<<  &SND_PCM_SFMT_GSM);}' unless defined(&SND_PCM_FMT_GSM);
    eval 'sub SND_PCM_FMT_SPECIAL () {(1<<  &SND_PCM_SFMT_SPECIAL);}' unless defined(&SND_PCM_FMT_SPECIAL);
    if(defined(&SND_LITTLE_ENDIAN)) {
	eval 'sub SND_PCM_FMT_S16 () { &SND_PCM_FMT_S16_LE;}' unless defined(&SND_PCM_FMT_S16);
	eval 'sub SND_PCM_FMT_U16 () { &SND_PCM_FMT_U16_LE;}' unless defined(&SND_PCM_FMT_U16);
	eval 'sub SND_PCM_FMT_S24 () { &SND_PCM_FMT_S24_LE;}' unless defined(&SND_PCM_FMT_S24);
	eval 'sub SND_PCM_FMT_U24 () { &SND_PCM_FMT_U24_LE;}' unless defined(&SND_PCM_FMT_U24);
	eval 'sub SND_PCM_FMT_S32 () { &SND_PCM_FMT_S32_LE;}' unless defined(&SND_PCM_FMT_S32);
	eval 'sub SND_PCM_FMT_U32 () { &SND_PCM_FMT_U32_LE;}' unless defined(&SND_PCM_FMT_U32);
	eval 'sub SND_PCM_FMT_FLOAT () { &SND_PCM_FMT_FLOAT_LE;}' unless defined(&SND_PCM_FMT_FLOAT);
	eval 'sub SND_PCM_FMT_FLOAT64 () { &SND_PCM_FMT_FLOAT64_LE;}' unless defined(&SND_PCM_FMT_FLOAT64);
	eval 'sub SND_PCM_FMT_IEC958_SUBFRAME () { &SND_PCM_FMT_IEC958_SUBFRAME_LE;}' unless defined(&SND_PCM_FMT_IEC958_SUBFRAME);
    }
    if(defined(&SND_BIG_ENDIAN)) {
	eval 'sub SND_PCM_FMT_S16 () { &SND_PCM_FMT_S16_BE;}' unless defined(&SND_PCM_FMT_S16);
	eval 'sub SND_PCM_FMT_U16 () { &SND_PCM_FMT_U16_BE;}' unless defined(&SND_PCM_FMT_U16);
	eval 'sub SND_PCM_FMT_S24 () { &SND_PCM_FMT_S24_BE;}' unless defined(&SND_PCM_FMT_S24);
	eval 'sub SND_PCM_FMT_U24 () { &SND_PCM_FMT_U24_BE;}' unless defined(&SND_PCM_FMT_U24);
	eval 'sub SND_PCM_FMT_S32 () { &SND_PCM_FMT_S32_BE;}' unless defined(&SND_PCM_FMT_S32);
	eval 'sub SND_PCM_FMT_U32 () { &SND_PCM_FMT_U32_BE;}' unless defined(&SND_PCM_FMT_U32);
	eval 'sub SND_PCM_FMT_FLOAT () { &SND_PCM_FMT_FLOAT_BE;}' unless defined(&SND_PCM_FMT_FLOAT);
	eval 'sub SND_PCM_FMT_FLOAT64 () { &SND_PCM_FMT_FLOAT64_BE;}' unless defined(&SND_PCM_FMT_FLOAT64);
	eval 'sub SND_PCM_FMT_IEC958_SUBFRAME () { &SND_PCM_FMT_IEC958_SUBFRAME_BE;}' unless defined(&SND_PCM_FMT_IEC958_SUBFRAME);
    }
    eval 'sub SND_PCM_RATE_CONTINUOUS () {(1<<0);}' unless defined(&SND_PCM_RATE_CONTINUOUS);
    eval 'sub SND_PCM_RATE_KNOT () {(1<<1);}' unless defined(&SND_PCM_RATE_KNOT);
    eval 'sub SND_PCM_RATE_8000 () {(1<<2);}' unless defined(&SND_PCM_RATE_8000);
    eval 'sub SND_PCM_RATE_11025 () {(1<<3);}' unless defined(&SND_PCM_RATE_11025);
    eval 'sub SND_PCM_RATE_16000 () {(1<<4);}' unless defined(&SND_PCM_RATE_16000);
    eval 'sub SND_PCM_RATE_22050 () {(1<<5);}' unless defined(&SND_PCM_RATE_22050);
    eval 'sub SND_PCM_RATE_32000 () {(1<<6);}' unless defined(&SND_PCM_RATE_32000);
    eval 'sub SND_PCM_RATE_44100 () {(1<<7);}' unless defined(&SND_PCM_RATE_44100);
    eval 'sub SND_PCM_RATE_48000 () {(1<<8);}' unless defined(&SND_PCM_RATE_48000);
    eval 'sub SND_PCM_RATE_88200 () {(1<<9);}' unless defined(&SND_PCM_RATE_88200);
    eval 'sub SND_PCM_RATE_96000 () {(1<<10);}' unless defined(&SND_PCM_RATE_96000);
    eval 'sub SND_PCM_RATE_176400 () {(1<<11);}' unless defined(&SND_PCM_RATE_176400);
    eval 'sub SND_PCM_RATE_192000 () {(1<<12);}' unless defined(&SND_PCM_RATE_192000);
    eval 'sub SND_PCM_RATE_8000_44100 () {( &SND_PCM_RATE_8000| &SND_PCM_RATE_11025|  &SND_PCM_RATE_16000| &SND_PCM_RATE_22050|  &SND_PCM_RATE_32000| &SND_PCM_RATE_44100);}' unless defined(&SND_PCM_RATE_8000_44100);
    eval 'sub SND_PCM_RATE_8000_48000 () {( &SND_PCM_RATE_8000_44100| &SND_PCM_RATE_48000);}' unless defined(&SND_PCM_RATE_8000_48000);
    eval 'sub SND_PCM_RATE_8000_96000 () {( &SND_PCM_RATE_8000_48000| &SND_PCM_RATE_88200|  &SND_PCM_RATE_96000);}' unless defined(&SND_PCM_RATE_8000_96000);
    eval 'sub SND_PCM_INFO_PLAYBACK () {0x00000001;}' unless defined(&SND_PCM_INFO_PLAYBACK);
    eval 'sub SND_PCM_INFO_CAPTURE () {0x00000002;}' unless defined(&SND_PCM_INFO_CAPTURE);
    eval 'sub SND_PCM_INFO_DUPLEX () {0x00000100;}' unless defined(&SND_PCM_INFO_DUPLEX);
    eval 'sub SND_PCM_INFO_DUPLEX_RATE () {0x00000200;}' unless defined(&SND_PCM_INFO_DUPLEX_RATE);
    eval 'sub SND_PCM_INFO_DUPLEX_MONO () {0x00000400;}' unless defined(&SND_PCM_INFO_DUPLEX_MONO);
    eval 'sub SND_PCM_CHNINFO_MMAP () {0x00000001;}' unless defined(&SND_PCM_CHNINFO_MMAP);
    eval 'sub SND_PCM_CHNINFO_STREAM () {0x00000002;}' unless defined(&SND_PCM_CHNINFO_STREAM);
    eval 'sub SND_PCM_CHNINFO_BLOCK () {0x00000004;}' unless defined(&SND_PCM_CHNINFO_BLOCK);
    eval 'sub SND_PCM_CHNINFO_BATCH () {0x00000010;}' unless defined(&SND_PCM_CHNINFO_BATCH);
    eval 'sub SND_PCM_CHNINFO_INTERLEAVE () {0x00000100;}' unless defined(&SND_PCM_CHNINFO_INTERLEAVE);
    eval 'sub SND_PCM_CHNINFO_NONINTERLEAVE () {0x00000200;}' unless defined(&SND_PCM_CHNINFO_NONINTERLEAVE);
    eval 'sub SND_PCM_CHNINFO_BLOCK_TRANSFER () {0x00010000;}' unless defined(&SND_PCM_CHNINFO_BLOCK_TRANSFER);
    eval 'sub SND_PCM_CHNINFO_OVERRANGE () {0x00020000;}' unless defined(&SND_PCM_CHNINFO_OVERRANGE);
    eval 'sub SND_PCM_CHNINFO_MMAP_VALID () {0x00040000;}' unless defined(&SND_PCM_CHNINFO_MMAP_VALID);
    eval 'sub SND_PCM_CHNINFO_PAUSE () {0x00080000;}' unless defined(&SND_PCM_CHNINFO_PAUSE);
    eval 'sub SND_PCM_CHNINFO_GLOBAL_PARAMS () {0x00100000;}' unless defined(&SND_PCM_CHNINFO_GLOBAL_PARAMS);
    eval 'sub SND_PCM_START_DATA () {0;}' unless defined(&SND_PCM_START_DATA);
    eval 'sub SND_PCM_START_FULL () {1;}' unless defined(&SND_PCM_START_FULL);
    eval 'sub SND_PCM_START_GO () {2;}' unless defined(&SND_PCM_START_GO);
    eval 'sub SND_PCM_STOP_STOP () {0;}' unless defined(&SND_PCM_STOP_STOP);
    eval 'sub SND_PCM_STOP_STOP_ERASE () {1;}' unless defined(&SND_PCM_STOP_STOP_ERASE);
    eval 'sub SND_PCM_STOP_ROLLOVER () {2;}' unless defined(&SND_PCM_STOP_ROLLOVER);
    eval 'sub SND_PCM_FILL_NONE () {0;}' unless defined(&SND_PCM_FILL_NONE);
    eval 'sub SND_PCM_FILL_SILENCE_WHOLE () {1;}' unless defined(&SND_PCM_FILL_SILENCE_WHOLE);
    eval 'sub SND_PCM_FILL_SILENCE () {2;}' unless defined(&SND_PCM_FILL_SILENCE);
    eval 'sub SND_PCM_STATUS_NOTREADY () {0;}' unless defined(&SND_PCM_STATUS_NOTREADY);
    eval 'sub SND_PCM_STATUS_READY () {1;}' unless defined(&SND_PCM_STATUS_READY);
    eval 'sub SND_PCM_STATUS_PREPARED () {2;}' unless defined(&SND_PCM_STATUS_PREPARED);
    eval 'sub SND_PCM_STATUS_RUNNING () {3;}' unless defined(&SND_PCM_STATUS_RUNNING);
    eval 'sub SND_PCM_STATUS_UNDERRUN () {4;}' unless defined(&SND_PCM_STATUS_UNDERRUN);
    eval 'sub SND_PCM_STATUS_OVERRUN () {5;}' unless defined(&SND_PCM_STATUS_OVERRUN);
    eval 'sub SND_PCM_STATUS_PAUSED () {6;}' unless defined(&SND_PCM_STATUS_PAUSED);
    eval 'sub SND_PCM_BOUNDARY () {0xf0000000;}' unless defined(&SND_PCM_BOUNDARY);
    eval 'sub SND_PCM_MMAP_OFFSET_CONTROL () {0x00000000;}' unless defined(&SND_PCM_MMAP_OFFSET_CONTROL);
    eval 'sub SND_PCM_MMAP_OFFSET_DATA () {0x80000000;}' unless defined(&SND_PCM_MMAP_OFFSET_DATA);
    eval 'sub SND_PCM_SW_RATE () {"Sample Rate";}' unless defined(&SND_PCM_SW_RATE);
    eval 'sub SND_PCM_SW_FORMAT () {"Format";}' unless defined(&SND_PCM_SW_FORMAT);
    eval 'sub SND_PCM_SW_VOICES () {"Voices";}' unless defined(&SND_PCM_SW_VOICES);
    eval 'sub SND_PCM_SW_FRAGMENT_SIZE () {"Fragment Size";}' unless defined(&SND_PCM_SW_FRAGMENT_SIZE);
    eval 'sub SND_PCM_DIG0_PROFESSIONAL () {(1<<0);}' unless defined(&SND_PCM_DIG0_PROFESSIONAL);
    eval 'sub SND_PCM_DIG0_NONAUDIO () {(1<<1);}' unless defined(&SND_PCM_DIG0_NONAUDIO);
    eval 'sub SND_PCM_DIG0_PRO_EMPHASIS () {(7<<2);}' unless defined(&SND_PCM_DIG0_PRO_EMPHASIS);
    eval 'sub SND_PCM_DIG0_PRO_EMPHASIS_NOTID () {(0<<2);}' unless defined(&SND_PCM_DIG0_PRO_EMPHASIS_NOTID);
    eval 'sub SND_PCM_DIG0_PRO_EMPHASIS_NONE () {(1<<2);}' unless defined(&SND_PCM_DIG0_PRO_EMPHASIS_NONE);
    eval 'sub SND_PCM_DIG0_PRO_EMPHASIS_5015 () {(3<<2);}' unless defined(&SND_PCM_DIG0_PRO_EMPHASIS_5015);
    eval 'sub SND_PCM_DIG0_PRO_EMPHASIS_CCITT () {(7<<2);}' unless defined(&SND_PCM_DIG0_PRO_EMPHASIS_CCITT);
    eval 'sub SND_PCM_DIG0_PRO_FREQ_UNLOCKED () {(1<<5);}' unless defined(&SND_PCM_DIG0_PRO_FREQ_UNLOCKED);
    eval 'sub SND_PCM_DIG0_PRO_FS () {(3<<6);}' unless defined(&SND_PCM_DIG0_PRO_FS);
    eval 'sub SND_PCM_DIG0_PRO_FS_NOTID () {(0<<6);}' unless defined(&SND_PCM_DIG0_PRO_FS_NOTID);
    eval 'sub SND_PCM_DIG0_PRO_FS_44100 () {(1<<6);}' unless defined(&SND_PCM_DIG0_PRO_FS_44100);
    eval 'sub SND_PCM_DIG0_PRO_FS_48000 () {(2<<6);}' unless defined(&SND_PCM_DIG0_PRO_FS_48000);
    eval 'sub SND_PCM_DIG0_PRO_FS_32000 () {(3<<6);}' unless defined(&SND_PCM_DIG0_PRO_FS_32000);
    eval 'sub SND_PCM_DIG0_CON_NOT_COPYRIGHT () {(1<<2);}' unless defined(&SND_PCM_DIG0_CON_NOT_COPYRIGHT);
    eval 'sub SND_PCM_DIG0_CON_EMPHASIS () {(7<<3);}' unless defined(&SND_PCM_DIG0_CON_EMPHASIS);
    eval 'sub SND_PCM_DIG0_CON_EMPHASIS_NONE () {(0<<3);}' unless defined(&SND_PCM_DIG0_CON_EMPHASIS_NONE);
    eval 'sub SND_PCM_DIG0_CON_EMPHASIS_5015 () {(1<<3);}' unless defined(&SND_PCM_DIG0_CON_EMPHASIS_5015);
    eval 'sub SND_PCM_DIG0_CON_MODE () {(3<<6);}' unless defined(&SND_PCM_DIG0_CON_MODE);
    eval 'sub SND_PCM_DIG1_PRO_MODE () {(15<<0);}' unless defined(&SND_PCM_DIG1_PRO_MODE);
    eval 'sub SND_PCM_DIG1_PRO_MODE_NOTID () {(0<<0);}' unless defined(&SND_PCM_DIG1_PRO_MODE_NOTID);
    eval 'sub SND_PCM_DIG1_PRO_MODE_STEREOPHONIC () {(2<<0);}' unless defined(&SND_PCM_DIG1_PRO_MODE_STEREOPHONIC);
    eval 'sub SND_PCM_DIG1_PRO_MODE_SINGLE () {(4<<0);}' unless defined(&SND_PCM_DIG1_PRO_MODE_SINGLE);
    eval 'sub SND_PCM_DIG1_PRO_MODE_TWO () {(8<<0);}' unless defined(&SND_PCM_DIG1_PRO_MODE_TWO);
    eval 'sub SND_PCM_DIG1_PRO_MODE_PRIMARY () {(12<<0);}' unless defined(&SND_PCM_DIG1_PRO_MODE_PRIMARY);
    eval 'sub SND_PCM_DIG1_PRO_MODE_BYTE3 () {(15<<0);}' unless defined(&SND_PCM_DIG1_PRO_MODE_BYTE3);
    eval 'sub SND_PCM_DIG1_PRO_USERBITS () {(15<<4);}' unless defined(&SND_PCM_DIG1_PRO_USERBITS);
    eval 'sub SND_PCM_DIG1_PRO_USERBITS_NOTID () {(0<<4);}' unless defined(&SND_PCM_DIG1_PRO_USERBITS_NOTID);
    eval 'sub SND_PCM_DIG1_PRO_USERBITS_192 () {(8<<4);}' unless defined(&SND_PCM_DIG1_PRO_USERBITS_192);
    eval 'sub SND_PCM_DIG1_PRO_USERBITS_UDEF () {(12<<4);}' unless defined(&SND_PCM_DIG1_PRO_USERBITS_UDEF);
    eval 'sub SND_PCM_DIG1_CON_CATEGORY () {0x7f;}' unless defined(&SND_PCM_DIG1_CON_CATEGORY);
    eval 'sub SND_PCM_DIG1_CON_GENERAL () {0x00;}' unless defined(&SND_PCM_DIG1_CON_GENERAL);
    eval 'sub SND_PCM_DIG1_CON_EXPERIMENTAL () {0x40;}' unless defined(&SND_PCM_DIG1_CON_EXPERIMENTAL);
    eval 'sub SND_PCM_DIG1_CON_SOLIDMEM_MASK () {0x0f;}' unless defined(&SND_PCM_DIG1_CON_SOLIDMEM_MASK);
    eval 'sub SND_PCM_DIG1_CON_SOLIDMEM_ID () {0x08;}' unless defined(&SND_PCM_DIG1_CON_SOLIDMEM_ID);
    eval 'sub SND_PCM_DIG1_CON_BROADCAST1_MASK () {0x07;}' unless defined(&SND_PCM_DIG1_CON_BROADCAST1_MASK);
    eval 'sub SND_PCM_DIG1_CON_BROADCAST1_ID () {0x04;}' unless defined(&SND_PCM_DIG1_CON_BROADCAST1_ID);
    eval 'sub SND_PCM_DIG1_CON_DIGDIGCONV_MASK () {0x07;}' unless defined(&SND_PCM_DIG1_CON_DIGDIGCONV_MASK);
    eval 'sub SND_PCM_DIG1_CON_DIGDIGCONV_ID () {0x02;}' unless defined(&SND_PCM_DIG1_CON_DIGDIGCONV_ID);
    eval 'sub SND_PCM_DIG1_CON_ADC_COPYRIGHT_MASK () {0x1f;}' unless defined(&SND_PCM_DIG1_CON_ADC_COPYRIGHT_MASK);
    eval 'sub SND_PCM_DIG1_CON_ADC_COPYRIGHT_ID () {0x06;}' unless defined(&SND_PCM_DIG1_CON_ADC_COPYRIGHT_ID);
    eval 'sub SND_PCM_DIG1_CON_ADC_MASK () {0x1f;}' unless defined(&SND_PCM_DIG1_CON_ADC_MASK);
    eval 'sub SND_PCM_DIG1_CON_ADC_ID () {0x16;}' unless defined(&SND_PCM_DIG1_CON_ADC_ID);
    eval 'sub SND_PCM_DIG1_CON_BROADCAST2_MASK () {0x0f;}' unless defined(&SND_PCM_DIG1_CON_BROADCAST2_MASK);
    eval 'sub SND_PCM_DIG1_CON_BROADCAST2_ID () {0x0e;}' unless defined(&SND_PCM_DIG1_CON_BROADCAST2_ID);
    eval 'sub SND_PCM_DIG1_CON_LASEROPT_MASK () {0x07;}' unless defined(&SND_PCM_DIG1_CON_LASEROPT_MASK);
    eval 'sub SND_PCM_DIG1_CON_LASEROPT_ID () {0x01;}' unless defined(&SND_PCM_DIG1_CON_LASEROPT_ID);
    eval 'sub SND_PCM_DIG1_CON_MUSICAL_MASK () {0x07;}' unless defined(&SND_PCM_DIG1_CON_MUSICAL_MASK);
    eval 'sub SND_PCM_DIG1_CON_MUSICAL_ID () {0x05;}' unless defined(&SND_PCM_DIG1_CON_MUSICAL_ID);
    eval 'sub SND_PCM_DIG1_CON_MAGNETIC_MASK () {0x07;}' unless defined(&SND_PCM_DIG1_CON_MAGNETIC_MASK);
    eval 'sub SND_PCM_DIG1_CON_MAGNETIC_ID () {0x03;}' unless defined(&SND_PCM_DIG1_CON_MAGNETIC_ID);
    eval 'sub SND_PCM_DIG1_CON_IEC908_CD () {( &SND_PCM_DIG1_CON_LASEROPT_ID|0x00);}' unless defined(&SND_PCM_DIG1_CON_IEC908_CD);
    eval 'sub SND_PCM_DIG1_CON_NON_IEC908_CD () {( &SND_PCM_DIG1_CON_LASEROPT_ID|0x08);}' unless defined(&SND_PCM_DIG1_CON_NON_IEC908_CD);
    eval 'sub SND_PCM_DIG1_CON_PCM_CODER () {( &SND_PCM_DIG1_CON_DIGDIGCONV_ID|0x00);}' unless defined(&SND_PCM_DIG1_CON_PCM_CODER);
    eval 'sub SND_PCM_DIG1_CON_SAMPLER () {( &SND_PCM_DIG1_CON_DIGDIGCONV_ID|0x20);}' unless defined(&SND_PCM_DIG1_CON_SAMPLER);
    eval 'sub SND_PCM_DIG1_CON_MIXER () {( &SND_PCM_DIG1_CON_DIGDIGCONV_ID|0x10);}' unless defined(&SND_PCM_DIG1_CON_MIXER);
    eval 'sub SND_PCM_DIG1_CON_RATE_CONVERTER () {( &SND_PCM_DIG1_CON_DIGDIGCONV_ID|0x18);}' unless defined(&SND_PCM_DIG1_CON_RATE_CONVERTER);
    eval 'sub SND_PCM_DIG1_CON_SYNTHESIZER () {( &SND_PCM_DIG1_CON_MUSICAL_ID|0x00);}' unless defined(&SND_PCM_DIG1_CON_SYNTHESIZER);
    eval 'sub SND_PCM_DIG1_CON_MICROPHONE () {( &SND_PCM_DIG1_CON_MUSICAL_ID|0x08);}' unless defined(&SND_PCM_DIG1_CON_MICROPHONE);
    eval 'sub SND_PCM_DIG1_CON_DAT () {( &SND_PCM_DIG1_CON_MAGNETIC_ID|0x00);}' unless defined(&SND_PCM_DIG1_CON_DAT);
    eval 'sub SND_PCM_DIG1_CON_VCR () {( &SND_PCM_DIG1_CON_MAGNETIC_ID|0x08);}' unless defined(&SND_PCM_DIG1_CON_VCR);
    eval 'sub SND_PCM_DIG1_CON_ORIGINAL () {(1<<7);}' unless defined(&SND_PCM_DIG1_CON_ORIGINAL);
    eval 'sub SND_PCM_DIG2_PRO_SBITS () {(7<<0);}' unless defined(&SND_PCM_DIG2_PRO_SBITS);
    eval 'sub SND_PCM_DIG2_PRO_SBITS_20 () {(2<<0);}' unless defined(&SND_PCM_DIG2_PRO_SBITS_20);
    eval 'sub SND_PCM_DIG2_PRO_SBITS_24 () {(4<<0);}' unless defined(&SND_PCM_DIG2_PRO_SBITS_24);
    eval 'sub SND_PCM_DIG2_PRO_SBITS_UDEF () {(6<<0);}' unless defined(&SND_PCM_DIG2_PRO_SBITS_UDEF);
    eval 'sub SND_PCM_DIG2_PRO_WORDLEN () {(7<<3);}' unless defined(&SND_PCM_DIG2_PRO_WORDLEN);
    eval 'sub SND_PCM_DIG2_PRO_WORDLEN_NOTID () {(0<<3);}' unless defined(&SND_PCM_DIG2_PRO_WORDLEN_NOTID);
    eval 'sub SND_PCM_DIG2_PRO_WORDLEN_22_18 () {(2<<3);}' unless defined(&SND_PCM_DIG2_PRO_WORDLEN_22_18);
    eval 'sub SND_PCM_DIG2_PRO_WORDLEN_23_19 () {(4<<3);}' unless defined(&SND_PCM_DIG2_PRO_WORDLEN_23_19);
    eval 'sub SND_PCM_DIG2_PRO_WORDLEN_24_20 () {(5<<3);}' unless defined(&SND_PCM_DIG2_PRO_WORDLEN_24_20);
    eval 'sub SND_PCM_DIG2_PRO_WORDLEN_20_16 () {(6<<3);}' unless defined(&SND_PCM_DIG2_PRO_WORDLEN_20_16);
    eval 'sub SND_PCM_DIG2_CON_SOURCE () {(15<<0);}' unless defined(&SND_PCM_DIG2_CON_SOURCE);
    eval 'sub SND_PCM_DIG2_CON_SOURCE_UNSPEC () {(0<<0);}' unless defined(&SND_PCM_DIG2_CON_SOURCE_UNSPEC);
    eval 'sub SND_PCM_DIG2_CON_CHANNEL () {(15<<4);}' unless defined(&SND_PCM_DIG2_CON_CHANNEL);
    eval 'sub SND_PCM_DIG2_CON_CHANNEL_UNSPEC () {(0<<4);}' unless defined(&SND_PCM_DIG2_CON_CHANNEL_UNSPEC);
    eval 'sub SND_PCM_DIG3_CON_FS () {(15<<0);}' unless defined(&SND_PCM_DIG3_CON_FS);
    eval 'sub SND_PCM_DIG3_CON_FS_44100 () {(0<<0);}' unless defined(&SND_PCM_DIG3_CON_FS_44100);
    eval 'sub SND_PCM_DIG3_CON_FS_48000 () {(2<<0);}' unless defined(&SND_PCM_DIG3_CON_FS_48000);
    eval 'sub SND_PCM_DIG3_CON_FS_32000 () {(3<<0);}' unless defined(&SND_PCM_DIG3_CON_FS_32000);
    eval 'sub SND_PCM_DIG3_CON_CLOCK () {(3<<4);}' unless defined(&SND_PCM_DIG3_CON_CLOCK);
    eval 'sub SND_PCM_DIG3_CON_CLOCK_1000PPM () {(0<<4);}' unless defined(&SND_PCM_DIG3_CON_CLOCK_1000PPM);
    eval 'sub SND_PCM_DIG3_CON_CLOCK_50PPM () {(1<<4);}' unless defined(&SND_PCM_DIG3_CON_CLOCK_50PPM);
    eval 'sub SND_PCM_DIG3_CON_CLOCK_VARIABLE () {(2<<4);}' unless defined(&SND_PCM_DIG3_CON_CLOCK_VARIABLE);
    eval 'sub SND_PCM_IOCTL_PVERSION () { &_IOR (ord(\'A\'), 0x00, \'int\');}' unless defined(&SND_PCM_IOCTL_PVERSION);
    eval 'sub SND_PCM_IOCTL_INFO () { &_IOR (ord(\'A\'), 0x01,  &snd_pcm_info_t);}' unless defined(&SND_PCM_IOCTL_INFO);
    eval 'sub SND_PCM_IOCTL_CHANNEL_INFO () { &_IOR (ord(\'A\'), 0x02,  &snd_pcm_channel_info_t);}' unless defined(&SND_PCM_IOCTL_CHANNEL_INFO);
    eval 'sub SND_PCM_IOCTL_CHANNEL_PARAMS () { &_IOW (ord(\'A\'), 0x10,  &snd_pcm_channel_params_t);}' unless defined(&SND_PCM_IOCTL_CHANNEL_PARAMS);
    eval 'sub SND_PCM_IOCTL_CHANNEL_SETUP () { &_IOR (ord(\'A\'), 0x20,  &snd_pcm_channel_setup_t);}' unless defined(&SND_PCM_IOCTL_CHANNEL_SETUP);
    eval 'sub SND_PCM_IOCTL_CHANNEL_STATUS () { &_IOR (ord(\'A\'), 0x21,  &snd_pcm_channel_status_t);}' unless defined(&SND_PCM_IOCTL_CHANNEL_STATUS);
    eval 'sub SND_PCM_IOCTL_CHANNEL_PREPARE () { &_IO (ord(\'A\'), 0x30);}' unless defined(&SND_PCM_IOCTL_CHANNEL_PREPARE);
    eval 'sub SND_PCM_IOCTL_CHANNEL_GO () { &_IO (ord(\'A\'), 0x31);}' unless defined(&SND_PCM_IOCTL_CHANNEL_GO);
    eval 'sub SND_PCM_IOCTL_CHANNEL_FLUSH () { &_IO (ord(\'A\'), 0x32);}' unless defined(&SND_PCM_IOCTL_CHANNEL_FLUSH);
    eval 'sub SND_PCM_IOCTL_SYNC_GO () { &_IOW (ord(\'A\'), 0x33,  &snd_pcm_sync_t);}' unless defined(&SND_PCM_IOCTL_SYNC_GO);
    eval 'sub SND_PCM_IOCTL_CHANNEL_DRAIN () { &_IO (ord(\'A\'), 0x34);}' unless defined(&SND_PCM_IOCTL_CHANNEL_DRAIN);
    eval 'sub SND_PCM_IOCTL_CHANNEL_PAUSE () { &_IOW (ord(\'A\'), 0x35, \'int\');}' unless defined(&SND_PCM_IOCTL_CHANNEL_PAUSE);
    eval 'sub SND_PCM_LB_VERSION () { &SND_PROTOCOL_VERSION(1, 0, 0);}' unless defined(&SND_PCM_LB_VERSION);
    eval 'sub SND_PCM_LB_STREAM_MODE_RAW () {0;}' unless defined(&SND_PCM_LB_STREAM_MODE_RAW);
    eval 'sub SND_PCM_LB_STREAM_MODE_PACKET () {1;}' unless defined(&SND_PCM_LB_STREAM_MODE_PACKET);
    eval 'sub SND_PCM_LB_TYPE_DATA () {0;}' unless defined(&SND_PCM_LB_TYPE_DATA);
    eval 'sub SND_PCM_LB_TYPE_FORMAT () {1;}' unless defined(&SND_PCM_LB_TYPE_FORMAT);
    eval 'sub SND_PCM_LB_TYPE_POSITION () {2;}' unless defined(&SND_PCM_LB_TYPE_POSITION);
    eval 'sub SND_PCM_LB_TYPE_SILENCE () {3;}' unless defined(&SND_PCM_LB_TYPE_SILENCE);
    eval 'sub SND_PCM_LB_IOCTL_PVERSION () { &_IOR (ord(\'L\'), 0x00, \'int\');}' unless defined(&SND_PCM_LB_IOCTL_PVERSION);
    eval 'sub SND_PCM_LB_IOCTL_STREAM_MODE () { &_IOW (ord(\'L\'), 0x01, \'int\');}' unless defined(&SND_PCM_LB_IOCTL_STREAM_MODE);
    eval 'sub SND_PCM_LB_IOCTL_FORMAT () { &_IOR (ord(\'L\'), 0x02,  &snd_pcm_format_t);}' unless defined(&SND_PCM_LB_IOCTL_FORMAT);
    eval 'sub SND_PCM_LB_IOCTL_STATUS () { &_IOR (ord(\'L\'), 0x03,  &snd_pcm_loopback_status_t);}' unless defined(&SND_PCM_LB_IOCTL_STATUS);
    if(defined(&__SND_OSS_COMPAT__)) {
	eval 'sub SND_PCM_AFMT_QUERY () {0;}' unless defined(&SND_PCM_AFMT_QUERY);
	eval 'sub SND_PCM_AFMT_MU_LAW () {(1<<0);}' unless defined(&SND_PCM_AFMT_MU_LAW);
	eval 'sub SND_PCM_AFMT_A_LAW () {(1<<1);}' unless defined(&SND_PCM_AFMT_A_LAW);
	eval 'sub SND_PCM_AFMT_IMA_ADPCM () {(1<<2);}' unless defined(&SND_PCM_AFMT_IMA_ADPCM);
	eval 'sub SND_PCM_AFMT_U8 () {(1<<3);}' unless defined(&SND_PCM_AFMT_U8);
	eval 'sub SND_PCM_AFMT_S16_LE () {(1<<4);}' unless defined(&SND_PCM_AFMT_S16_LE);
	eval 'sub SND_PCM_AFMT_S16_BE () {(1<<5);}' unless defined(&SND_PCM_AFMT_S16_BE);
	eval 'sub SND_PCM_AFMT_S8 () {(1<<6);}' unless defined(&SND_PCM_AFMT_S8);
	eval 'sub SND_PCM_AFMT_U16_LE () {(1<<7);}' unless defined(&SND_PCM_AFMT_U16_LE);
	eval 'sub SND_PCM_AFMT_U16_BE () {(1<<8);}' unless defined(&SND_PCM_AFMT_U16_BE);
	eval 'sub SND_PCM_AFMT_MPEG () {(1<<9);}' unless defined(&SND_PCM_AFMT_MPEG);
	eval 'sub SND_PCM_ENABLE_CAPTURE () {0x00000001;}' unless defined(&SND_PCM_ENABLE_CAPTURE);
	eval 'sub SND_PCM_ENABLE_PLAYBACK () {0x00000002;}' unless defined(&SND_PCM_ENABLE_PLAYBACK);
	eval 'sub SND_PCM_CAP_REVISION () {0x000000ff;}' unless defined(&SND_PCM_CAP_REVISION);
	eval 'sub SND_PCM_CAP_DUPLEX () {0x00000100;}' unless defined(&SND_PCM_CAP_DUPLEX);
	eval 'sub SND_PCM_CAP_REALTIME () {0x00000200;}' unless defined(&SND_PCM_CAP_REALTIME);
	eval 'sub SND_PCM_CAP_BATCH () {0x00000400;}' unless defined(&SND_PCM_CAP_BATCH);
	eval 'sub SND_PCM_CAP_COPROC () {0x00000800;}' unless defined(&SND_PCM_CAP_COPROC);
	eval 'sub SND_PCM_CAP_TRIGGER () {0x00001000;}' unless defined(&SND_PCM_CAP_TRIGGER);
	eval 'sub SND_PCM_CAP_MMAP () {0x00002000;}' unless defined(&SND_PCM_CAP_MMAP);
	eval 'sub SND_PCM_AFP_NORMAL () {0;}' unless defined(&SND_PCM_AFP_NORMAL);
	eval 'sub SND_PCM_AFP_NETWORK () {1;}' unless defined(&SND_PCM_AFP_NETWORK);
	eval 'sub SND_PCM_AFP_CPUINTENS () {2;}' unless defined(&SND_PCM_AFP_CPUINTENS);
	eval 'sub SND_PCM_IOCTL_OSS_RESET () { &_IO (ord(\'P\'), 0);}' unless defined(&SND_PCM_IOCTL_OSS_RESET);
	eval 'sub SND_PCM_IOCTL_OSS_SYNC () { &_IO (ord(\'P\'), 1);}' unless defined(&SND_PCM_IOCTL_OSS_SYNC);
	eval 'sub SND_PCM_IOCTL_OSS_RATE () { &_IOWR(ord(\'P\'), 2, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_RATE);
	eval 'sub SND_PCM_IOCTL_OSS_GETRATE () { &_IOR (ord(\'P\'), 2, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_GETRATE);
	eval 'sub SND_PCM_IOCTL_OSS_STEREO () { &_IOWR(ord(\'P\'), 3, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_STEREO);
	eval 'sub SND_PCM_IOCTL_OSS_GETBLKSIZE () { &_IOWR(ord(\'P\'), 4, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_GETBLKSIZE);
	eval 'sub SND_PCM_IOCTL_OSS_FORMAT () { &_IOWR(ord(\'P\'), 5, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_FORMAT);
	eval 'sub SND_PCM_IOCTL_OSS_GETFORMAT () { &_IOR (ord(\'P\'), 5, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_GETFORMAT);
	eval 'sub SND_PCM_IOCTL_OSS_CHANNELS () { &_IOWR(ord(\'P\'), 6, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_CHANNELS);
	eval 'sub SND_PCM_IOCTL_OSS_GETCHANNELS () { &_IOR (ord(\'P\'), 6, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_GETCHANNELS);
	eval 'sub SND_PCM_IOCTL_OSS_FILTER () { &_IOWR(ord(\'P\'), 7, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_FILTER);
	eval 'sub SND_PCM_IOCTL_OSS_GETFILTER () { &_IOR (ord(\'P\'), 7, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_GETFILTER);
	eval 'sub SND_PCM_IOCTL_OSS_POST () { &_IO (ord(\'P\'), 8);}' unless defined(&SND_PCM_IOCTL_OSS_POST);
	eval 'sub SND_PCM_IOCTL_OSS_SUBDIVIDE () { &_IOWR(ord(\'P\'), 9, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_SUBDIVIDE);
	eval 'sub SND_PCM_IOCTL_OSS_SETFRAGMENT () { &_IOWR(ord(\'P\'), 10, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_SETFRAGMENT);
	eval 'sub SND_PCM_IOCTL_OSS_GETFORMATS () { &_IOR (ord(\'P\'), 11, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_GETFORMATS);
	eval 'sub SND_PCM_IOCTL_OSS_GETPBKSPACE () { &_IOR (ord(\'P\'), 12, \'struct snd_pcm_buffer_info\');}' unless defined(&SND_PCM_IOCTL_OSS_GETPBKSPACE);
	eval 'sub SND_PCM_IOCTL_OSS_GETRECSPACE () { &_IOR (ord(\'P\'), 13, \'struct snd_pcm_buffer_info\');}' unless defined(&SND_PCM_IOCTL_OSS_GETRECSPACE);
	eval 'sub SND_PCM_IOCTL_OSS_NONBLOCK () { &_IO (ord(\'P\'), 14);}' unless defined(&SND_PCM_IOCTL_OSS_NONBLOCK);
	eval 'sub SND_PCM_IOCTL_OSS_GETCAPS () { &_IOR (ord(\'P\'), 15, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_GETCAPS);
	eval 'sub SND_PCM_IOCTL_OSS_GETTRIGGER () { &_IOR (ord(\'P\'), 16, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_GETTRIGGER);
	eval 'sub SND_PCM_IOCTL_OSS_SETTRIGGER () { &_IOW (ord(\'P\'), 16, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_SETTRIGGER);
	eval 'sub SND_PCM_IOCTL_OSS_GETRECPTR () { &_IOR (ord(\'P\'), 17, \'struct snd_pcm_count_info\');}' unless defined(&SND_PCM_IOCTL_OSS_GETRECPTR);
	eval 'sub SND_PCM_IOCTL_OSS_GETPBKPTR () { &_IOR (ord(\'P\'), 18, \'struct snd_pcm_count_info\');}' unless defined(&SND_PCM_IOCTL_OSS_GETPBKPTR);
	eval 'sub SND_PCM_IOCTL_OSS_MAPRECBUFFER () { &_IOR (ord(\'P\'), 19, \'struct snd_pcm_buffer_description\');}' unless defined(&SND_PCM_IOCTL_OSS_MAPRECBUFFER);
	eval 'sub SND_PCM_IOCTL_OSS_MAPPBKBUFFER () { &_IOR (ord(\'P\'), 20, \'struct snd_pcm_buffer_description\');}' unless defined(&SND_PCM_IOCTL_OSS_MAPPBKBUFFER);
	eval 'sub SND_PCM_IOCTL_OSS_SYNCRO () { &_IO (ord(\'P\'), 21);}' unless defined(&SND_PCM_IOCTL_OSS_SYNCRO);
	eval 'sub SND_PCM_IOCTL_OSS_DUPLEX () { &_IO (ord(\'P\'), 22);}' unless defined(&SND_PCM_IOCTL_OSS_DUPLEX);
	eval 'sub SND_PCM_IOCTL_OSS_GETODELAY () { &_IOR (ord(\'P\'), 23, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_GETODELAY);
	eval 'sub SND_PCM_IOCTL_OSS_PROFILE () { &_IOW (ord(\'P\'), 23, \'int\');}' unless defined(&SND_PCM_IOCTL_OSS_PROFILE);
    }
    eval 'sub SND_MIDI_CHANNELS () {16;}' unless defined(&SND_MIDI_CHANNELS);
    eval 'sub SND_MIDI_GM_DRUM_CHANNEL () {(10-1);}' unless defined(&SND_MIDI_GM_DRUM_CHANNEL);
    eval 'sub SND_MCMD_NOTE_OFF () {0x80;}' unless defined(&SND_MCMD_NOTE_OFF);
    eval 'sub SND_MCMD_NOTE_ON () {0x90;}' unless defined(&SND_MCMD_NOTE_ON);
    eval 'sub SND_MCMD_NOTE_PRESSURE () {0xa0;}' unless defined(&SND_MCMD_NOTE_PRESSURE);
    eval 'sub SND_MCMD_CONTROL () {0xb0;}' unless defined(&SND_MCMD_CONTROL);
    eval 'sub SND_MCMD_PGM_CHANGE () {0xc0;}' unless defined(&SND_MCMD_PGM_CHANGE);
    eval 'sub SND_MCMD_CHANNEL_PRESSURE () {0xd0;}' unless defined(&SND_MCMD_CHANNEL_PRESSURE);
    eval 'sub SND_MCMD_BENDER () {0xe0;}' unless defined(&SND_MCMD_BENDER);
    eval 'sub SND_MCMD_COMMON_SYSEX () {0xf0;}' unless defined(&SND_MCMD_COMMON_SYSEX);
    eval 'sub SND_MCMD_COMMON_MTC_QUARTER () {0xf1;}' unless defined(&SND_MCMD_COMMON_MTC_QUARTER);
    eval 'sub SND_MCMD_COMMON_SONG_POS () {0xf2;}' unless defined(&SND_MCMD_COMMON_SONG_POS);
    eval 'sub SND_MCMD_COMMON_SONG_SELECT () {0xf3;}' unless defined(&SND_MCMD_COMMON_SONG_SELECT);
    eval 'sub SND_MCMD_COMMON_TUNE_REQUEST () {0xf6;}' unless defined(&SND_MCMD_COMMON_TUNE_REQUEST);
    eval 'sub SND_MCMD_COMMON_SYSEX_END () {0xf7;}' unless defined(&SND_MCMD_COMMON_SYSEX_END);
    eval 'sub SND_MCMD_COMMON_CLOCK () {0xf8;}' unless defined(&SND_MCMD_COMMON_CLOCK);
    eval 'sub SND_MCMD_COMMON_START () {0xfa;}' unless defined(&SND_MCMD_COMMON_START);
    eval 'sub SND_MCMD_COMMON_CONTINUE () {0xfb;}' unless defined(&SND_MCMD_COMMON_CONTINUE);
    eval 'sub SND_MCMD_COMMON_STOP () {0xfc;}' unless defined(&SND_MCMD_COMMON_STOP);
    eval 'sub SND_MCMD_COMMON_SENSING () {0xfe;}' unless defined(&SND_MCMD_COMMON_SENSING);
    eval 'sub SND_MCMD_COMMON_RESET () {0xff;}' unless defined(&SND_MCMD_COMMON_RESET);
    eval 'sub SND_MCTL_MSB_BANK () {0x00;}' unless defined(&SND_MCTL_MSB_BANK);
    eval 'sub SND_MCTL_MSB_MODWHEEL () {0x01;}' unless defined(&SND_MCTL_MSB_MODWHEEL);
    eval 'sub SND_MCTL_MSB_BREATH () {0x02;}' unless defined(&SND_MCTL_MSB_BREATH);
    eval 'sub SND_MCTL_MSB_FOOT () {0x04;}' unless defined(&SND_MCTL_MSB_FOOT);
    eval 'sub SND_MCTL_MSB_PORTNAMENTO_TIME () {0x05;}' unless defined(&SND_MCTL_MSB_PORTNAMENTO_TIME);
    eval 'sub SND_MCTL_MSB_DATA_ENTRY () {0x06;}' unless defined(&SND_MCTL_MSB_DATA_ENTRY);
    eval 'sub SND_MCTL_MSB_MAIN_VOLUME () {0x07;}' unless defined(&SND_MCTL_MSB_MAIN_VOLUME);
    eval 'sub SND_MCTL_MSB_BALANCE () {0x08;}' unless defined(&SND_MCTL_MSB_BALANCE);
    eval 'sub SND_MCTL_MSB_PAN () {0x0a;}' unless defined(&SND_MCTL_MSB_PAN);
    eval 'sub SND_MCTL_MSB_EXPRESSION () {0x0b;}' unless defined(&SND_MCTL_MSB_EXPRESSION);
    eval 'sub SND_MCTL_MSB_EFFECT1 () {0x0c;}' unless defined(&SND_MCTL_MSB_EFFECT1);
    eval 'sub SND_MCTL_MSB_EFFECT2 () {0x0d;}' unless defined(&SND_MCTL_MSB_EFFECT2);
    eval 'sub SND_MCTL_MSB_GENERAL_PURPOSE1 () {0x10;}' unless defined(&SND_MCTL_MSB_GENERAL_PURPOSE1);
    eval 'sub SND_MCTL_MSB_GENERAL_PURPOSE2 () {0x11;}' unless defined(&SND_MCTL_MSB_GENERAL_PURPOSE2);
    eval 'sub SND_MCTL_MSB_GENERAL_PURPOSE3 () {0x12;}' unless defined(&SND_MCTL_MSB_GENERAL_PURPOSE3);
    eval 'sub SND_MCTL_MSB_GENERAL_PURPOSE4 () {0x13;}' unless defined(&SND_MCTL_MSB_GENERAL_PURPOSE4);
    eval 'sub SND_MCTL_LSB_BANK () {0x20;}' unless defined(&SND_MCTL_LSB_BANK);
    eval 'sub SND_MCTL_LSB_MODWHEEL () {0x21;}' unless defined(&SND_MCTL_LSB_MODWHEEL);
    eval 'sub SND_MCTL_LSB_BREATH () {0x22;}' unless defined(&SND_MCTL_LSB_BREATH);
    eval 'sub SND_MCTL_LSB_FOOT () {0x24;}' unless defined(&SND_MCTL_LSB_FOOT);
    eval 'sub SND_MCTL_LSB_PORTNAMENTO_TIME () {0x25;}' unless defined(&SND_MCTL_LSB_PORTNAMENTO_TIME);
    eval 'sub SND_MCTL_LSB_DATA_ENTRY () {0x26;}' unless defined(&SND_MCTL_LSB_DATA_ENTRY);
    eval 'sub SND_MCTL_LSB_MAIN_VOLUME () {0x27;}' unless defined(&SND_MCTL_LSB_MAIN_VOLUME);
    eval 'sub SND_MCTL_LSB_BALANCE () {0x28;}' unless defined(&SND_MCTL_LSB_BALANCE);
    eval 'sub SND_MCTL_LSB_PAN () {0x2a;}' unless defined(&SND_MCTL_LSB_PAN);
    eval 'sub SND_MCTL_LSB_EXPRESSION () {0x2b;}' unless defined(&SND_MCTL_LSB_EXPRESSION);
    eval 'sub SND_MCTL_LSB_EFFECT1 () {0x2c;}' unless defined(&SND_MCTL_LSB_EFFECT1);
    eval 'sub SND_MCTL_LSB_EFFECT2 () {0x2d;}' unless defined(&SND_MCTL_LSB_EFFECT2);
    eval 'sub SND_MCTL_LSB_GENERAL_PURPOSE1 () {0x30;}' unless defined(&SND_MCTL_LSB_GENERAL_PURPOSE1);
    eval 'sub SND_MCTL_LSB_GENERAL_PURPOSE2 () {0x31;}' unless defined(&SND_MCTL_LSB_GENERAL_PURPOSE2);
    eval 'sub SND_MCTL_LSB_GENERAL_PURPOSE3 () {0x32;}' unless defined(&SND_MCTL_LSB_GENERAL_PURPOSE3);
    eval 'sub SND_MCTL_LSB_GENERAL_PURPOSE4 () {0x33;}' unless defined(&SND_MCTL_LSB_GENERAL_PURPOSE4);
    eval 'sub SND_MCTL_SUSTAIN () {0x40;}' unless defined(&SND_MCTL_SUSTAIN);
    eval 'sub SND_MCTL_PORTAMENTO () {0x41;}' unless defined(&SND_MCTL_PORTAMENTO);
    eval 'sub SND_MCTL_SUSTENUTO () {0x42;}' unless defined(&SND_MCTL_SUSTENUTO);
    eval 'sub SND_MCTL_SOFT_PEDAL () {0x43;}' unless defined(&SND_MCTL_SOFT_PEDAL);
    eval 'sub SND_MCTL_LEGATO_FOOTSWITCH () {0x44;}' unless defined(&SND_MCTL_LEGATO_FOOTSWITCH);
    eval 'sub SND_MCTL_HOLD2 () {0x45;}' unless defined(&SND_MCTL_HOLD2);
    eval 'sub SND_MCTL_SC1_SOUND_VARIATION () {0x46;}' unless defined(&SND_MCTL_SC1_SOUND_VARIATION);
    eval 'sub SND_MCTL_SC2_TIMBRE () {0x47;}' unless defined(&SND_MCTL_SC2_TIMBRE);
    eval 'sub SND_MCTL_SC3_RELEASE_TIME () {0x48;}' unless defined(&SND_MCTL_SC3_RELEASE_TIME);
    eval 'sub SND_MCTL_SC4_ATTACK_TIME () {0x49;}' unless defined(&SND_MCTL_SC4_ATTACK_TIME);
    eval 'sub SND_MCTL_SC5_BRIGHTNESS () {0x4a;}' unless defined(&SND_MCTL_SC5_BRIGHTNESS);
    eval 'sub SND_MCTL_SC6 () {0x4b;}' unless defined(&SND_MCTL_SC6);
    eval 'sub SND_MCTL_SC7 () {0x4c;}' unless defined(&SND_MCTL_SC7);
    eval 'sub SND_MCTL_SC8 () {0x4d;}' unless defined(&SND_MCTL_SC8);
    eval 'sub SND_MCTL_SC9 () {0x4e;}' unless defined(&SND_MCTL_SC9);
    eval 'sub SND_MCTL_SC10 () {0x4f;}' unless defined(&SND_MCTL_SC10);
    eval 'sub SND_MCTL_GENERAL_PURPOSE5 () {0x50;}' unless defined(&SND_MCTL_GENERAL_PURPOSE5);
    eval 'sub SND_MCTL_GENERAL_PURPOSE6 () {0x51;}' unless defined(&SND_MCTL_GENERAL_PURPOSE6);
    eval 'sub SND_MCTL_GENERAL_PURPOSE7 () {0x52;}' unless defined(&SND_MCTL_GENERAL_PURPOSE7);
    eval 'sub SND_MCTL_GENERAL_PURPOSE8 () {0x53;}' unless defined(&SND_MCTL_GENERAL_PURPOSE8);
    eval 'sub SND_MCTL_PORNAMENTO_CONTROL () {0x54;}' unless defined(&SND_MCTL_PORNAMENTO_CONTROL);
    eval 'sub SND_MCTL_E1_REVERB_DEPTH () {0x5b;}' unless defined(&SND_MCTL_E1_REVERB_DEPTH);
    eval 'sub SND_MCTL_E2_TREMOLO_DEPTH () {0x5c;}' unless defined(&SND_MCTL_E2_TREMOLO_DEPTH);
    eval 'sub SND_MCTL_E3_CHORUS_DEPTH () {0x5d;}' unless defined(&SND_MCTL_E3_CHORUS_DEPTH);
    eval 'sub SND_MCTL_E4_DETUNE_DEPTH () {0x5e;}' unless defined(&SND_MCTL_E4_DETUNE_DEPTH);
    eval 'sub SND_MCTL_E5_PHASER_DEPTH () {0x5f;}' unless defined(&SND_MCTL_E5_PHASER_DEPTH);
    eval 'sub SND_MCTL_DATA_INCREMENT () {0x60;}' unless defined(&SND_MCTL_DATA_INCREMENT);
    eval 'sub SND_MCTL_DATA_DECREMENT () {0x61;}' unless defined(&SND_MCTL_DATA_DECREMENT);
    eval 'sub SND_MCTL_NONREG_PARM_NUM_LSB () {0x62;}' unless defined(&SND_MCTL_NONREG_PARM_NUM_LSB);
    eval 'sub SND_MCTL_NONREG_PARM_NUM_MSB () {0x63;}' unless defined(&SND_MCTL_NONREG_PARM_NUM_MSB);
    eval 'sub SND_MCTL_REGIST_PARM_NUM_LSB () {0x64;}' unless defined(&SND_MCTL_REGIST_PARM_NUM_LSB);
    eval 'sub SND_MCTL_REGIST_PARM_NUM_MSB () {0x65;}' unless defined(&SND_MCTL_REGIST_PARM_NUM_MSB);
    eval 'sub SND_MCTL_ALL_SOUNDS_OFF () {0x78;}' unless defined(&SND_MCTL_ALL_SOUNDS_OFF);
    eval 'sub SND_MCTL_RESET_CONTROLLERS () {0x79;}' unless defined(&SND_MCTL_RESET_CONTROLLERS);
    eval 'sub SND_MCTL_LOCAL_CONTROL_SWITCH () {0x7a;}' unless defined(&SND_MCTL_LOCAL_CONTROL_SWITCH);
    eval 'sub SND_MCTL_ALL_NOTES_OFF () {0x7b;}' unless defined(&SND_MCTL_ALL_NOTES_OFF);
    eval 'sub SND_MCTL_OMNI_OFF () {0x7c;}' unless defined(&SND_MCTL_OMNI_OFF);
    eval 'sub SND_MCTL_OMNI_ON () {0x7d;}' unless defined(&SND_MCTL_OMNI_ON);
    eval 'sub SND_MCTL_MONO1 () {0x7e;}' unless defined(&SND_MCTL_MONO1);
    eval 'sub SND_MCTL_MONO2 () {0x7f;}' unless defined(&SND_MCTL_MONO2);
    eval 'sub SND_RAWMIDI_VERSION () { &SND_PROTOCOL_VERSION(1, 0, 0);}' unless defined(&SND_RAWMIDI_VERSION);
    eval 'sub SND_RAWMIDI_CHANNEL_OUTPUT () {0;}' unless defined(&SND_RAWMIDI_CHANNEL_OUTPUT);
    eval 'sub SND_RAWMIDI_CHANNEL_INPUT () {1;}' unless defined(&SND_RAWMIDI_CHANNEL_INPUT);
    eval 'sub SND_RAWMIDI_INFO_OUTPUT () {0x00000001;}' unless defined(&SND_RAWMIDI_INFO_OUTPUT);
    eval 'sub SND_RAWMIDI_INFO_INPUT () {0x00000002;}' unless defined(&SND_RAWMIDI_INFO_INPUT);
    eval 'sub SND_RAWMIDI_INFO_DUPLEX () {0x00000004;}' unless defined(&SND_RAWMIDI_INFO_DUPLEX);
    eval 'sub SND_RAWMIDI_IOCTL_PVERSION () { &_IOR (ord(\'W\'), 0x00, \'int\');}' unless defined(&SND_RAWMIDI_IOCTL_PVERSION);
    eval 'sub SND_RAWMIDI_IOCTL_INFO () { &_IOR (ord(\'W\'), 0x01,  &snd_rawmidi_info_t);}' unless defined(&SND_RAWMIDI_IOCTL_INFO);
    eval 'sub SND_RAWMIDI_IOCTL_CHANNEL_PARAMS () { &_IOW (ord(\'W\'), 0x10,  &snd_rawmidi_params_t);}' unless defined(&SND_RAWMIDI_IOCTL_CHANNEL_PARAMS);
    eval 'sub SND_RAWMIDI_IOCTL_CHANNEL_STATUS () { &_IOWR(ord(\'W\'), 0x20,  &snd_rawmidi_status_t);}' unless defined(&SND_RAWMIDI_IOCTL_CHANNEL_STATUS);
    eval 'sub SND_RAWMIDI_IOCTL_CHANNEL_DRAIN () { &_IOW (ord(\'W\'), 0x30, \'int\');}' unless defined(&SND_RAWMIDI_IOCTL_CHANNEL_DRAIN);
    eval 'sub SND_RAWMIDI_IOCTL_CHANNEL_FLUSH () { &_IOW (ord(\'W\'), 0x31, \'int\');}' unless defined(&SND_RAWMIDI_IOCTL_CHANNEL_FLUSH);
    eval 'sub SND_TIMER_VERSION () { &SND_PROTOCOL_VERSION(1, 0, 0);}' unless defined(&SND_TIMER_VERSION);
    eval 'sub SND_TIMER_TYPE_GLOBAL () {(0<<28);}' unless defined(&SND_TIMER_TYPE_GLOBAL);
    eval 'sub SND_TIMER_TYPE_SOUNDCARD () {(1<<28);}' unless defined(&SND_TIMER_TYPE_SOUNDCARD);
    eval 'sub SND_TIMER_TYPE_PCM () {(2<<28);}' unless defined(&SND_TIMER_TYPE_PCM);
    eval 'sub SND_TIMER_TYPE_MAX () {(7<<28);}' unless defined(&SND_TIMER_TYPE_MAX);
    eval 'sub SND_TIMER_TYPE {
        local($tmr) = @_;
	    eval q(((($tmr) >> 28) & 0x3f));
    }' unless defined(&SND_TIMER_TYPE);
    eval 'sub SND_TIMER_GLOBAL_MAX () {0x000003ff;}' unless defined(&SND_TIMER_GLOBAL_MAX);
    eval 'sub SND_TIMER_GLOBAL {
        local($tmr) = @_;
	    eval q((($tmr) &  &SND_TIMER_GLOBAL_MAX));
    }' unless defined(&SND_TIMER_GLOBAL);
    eval 'sub SND_TIMER_GLOBAL_SYSTEM () {0;}' unless defined(&SND_TIMER_GLOBAL_SYSTEM);
    eval 'sub SND_TIMER_SOUNDCARD_CARD_MAX () {( &SND_CARDS-1);}' unless defined(&SND_TIMER_SOUNDCARD_CARD_MAX);
    eval 'sub SND_TIMER_SOUNDCARD_CARD_SHIFT () {22;}' unless defined(&SND_TIMER_SOUNDCARD_CARD_SHIFT);
    eval 'sub SND_TIMER_SOUNDCARD_CARD {
        local($tmr) = @_;
	    eval q(((($tmr) >>  &SND_TIMER_SOUNDCARD_CARD_SHIFT) &  &SND_TIMER_SOUNDCARD_CARD_MAX));
    }' unless defined(&SND_TIMER_SOUNDCARD_CARD);
    eval 'sub SND_TIMER_SOUNDCARD_DEV_MAX () {0x003fffff;}' unless defined(&SND_TIMER_SOUNDCARD_DEV_MAX);
    eval 'sub SND_TIMER_SOUNDCARD_DEV {
        local($tmr) = @_;
	    eval q((($tmr) &  &SND_TIMER_SOUNDCARD_DEV_MAX));
    }' unless defined(&SND_TIMER_SOUNDCARD_DEV);
    eval 'sub SND_TIMER_SOUNDCARD {
        local($card,$dev) = @_;
	    eval q(( &SND_TIMER_TYPE_SOUNDCARD|((($card) &SND_TIMER_SOUNDCARD_CARD_MAX)<< &SND_TIMER_SOUNDCARD_CARD_SHIFT)|(($dev) &SND_TIMER_SOUNDCARD_DEV_MAX)));
    }' unless defined(&SND_TIMER_SOUNDCARD);
    if((defined(&SND_CARDS) ? &SND_CARDS : 0) > 64) {
	die("There is not enough space for the timer identifier.");
    }
    eval 'sub SND_TIMER_PCM_CARD_MAX () {( &SND_CARDS-1);}' unless defined(&SND_TIMER_PCM_CARD_MAX);
    eval 'sub SND_TIMER_PCM_CARD_SHIFT () {22;}' unless defined(&SND_TIMER_PCM_CARD_SHIFT);
    eval 'sub SND_TIMER_PCM_CARD {
        local($tmr) = @_;
	    eval q(((($tmr) >>  &SND_TIMER_PCM_CARD_SHIFT) &  &SND_TIMER_PCM_CARD_MAX));
    }' unless defined(&SND_TIMER_PCM_CARD);
    eval 'sub SND_TIMER_PCM_DEV_MAX () {0x000003ff;}' unless defined(&SND_TIMER_PCM_DEV_MAX);
    eval 'sub SND_TIMER_PCM_DEV_SHIFT () {12;}' unless defined(&SND_TIMER_PCM_DEV_SHIFT);
    eval 'sub SND_TIMER_PCM_DEV {
        local($tmr) = @_;
	    eval q(((($tmr) >>  &SND_TIMER_PCM_DEV_SHIFT) &  &SND_TIMER_PCM_DEV_MAX));
    }' unless defined(&SND_TIMER_PCM_DEV);
    eval 'sub SND_TIMER_PCM_SUBDEV_MAX () {0x00000fff;}' unless defined(&SND_TIMER_PCM_SUBDEV_MAX);
    eval 'sub SND_TIMER_PCM_SUBDEV {
        local($tmr) = @_;
	    eval q(($tmr &  &SND_TIMER_PCM_SUBDEV_MAX));
    }' unless defined(&SND_TIMER_PCM_SUBDEV);
    eval 'sub SND_TIMER_PCM {
        local($card,$dev,$subdev) = @_;
	    eval q(( &SND_TIMER_TYPE_PCM|((($card) &SND_TIMER_PCM_CARD_MAX)<< &SND_TIMER_PCM_CARD_SHIFT)|((($dev) &SND_TIMER_PCM_DEV_MAX)<< &SND_TIMER_PCM_DEV_SHIFT)|(($subdev) &SND_TIMER_PCM_SUBDEV_MAX)));
    }' unless defined(&SND_TIMER_PCM);
    eval 'sub SND_TIMER_STYPE_NONE () {0;}' unless defined(&SND_TIMER_STYPE_NONE);
    eval 'sub SND_TIMER_STYPE_APPLICATION () {1;}' unless defined(&SND_TIMER_STYPE_APPLICATION);
    eval 'sub SND_TIMER_STYPE_SEQUENCER () {2;}' unless defined(&SND_TIMER_STYPE_SEQUENCER);
    eval 'sub SND_TIMER_STYPE_OSS_SEQUENCER () {3;}' unless defined(&SND_TIMER_STYPE_OSS_SEQUENCER);
    eval 'sub SND_TIMER_FLG_SLAVE () {(1<<0);}' unless defined(&SND_TIMER_FLG_SLAVE);
    eval 'sub SND_TIMER_PSFLG_AUTO () {(1<<0);}' unless defined(&SND_TIMER_PSFLG_AUTO);
    eval 'sub SND_TIMER_IOCTL_PVERSION () { &_IOR (ord(\'T\'), 0x00, \'int\');}' unless defined(&SND_TIMER_IOCTL_PVERSION);
    eval 'sub SND_TIMER_IOCTL_GINFO () { &_IOW (ord(\'T\'), 0x01,  &snd_timer_general_info_t);}' unless defined(&SND_TIMER_IOCTL_GINFO);
    eval 'sub SND_TIMER_IOCTL_SELECT () { &_IOW (ord(\'T\'), 0x10,  &snd_timer_select_t);}' unless defined(&SND_TIMER_IOCTL_SELECT);
    eval 'sub SND_TIMER_IOCTL_INFO () { &_IOR (ord(\'T\'), 0x11,  &snd_timer_info_t);}' unless defined(&SND_TIMER_IOCTL_INFO);
    eval 'sub SND_TIMER_IOCTL_PARAMS () { &_IOW (ord(\'T\'), 0x12,  &snd_timer_params_t);}' unless defined(&SND_TIMER_IOCTL_PARAMS);
    eval 'sub SND_TIMER_IOCTL_STATUS () { &_IOW (ord(\'T\'), 0x13,  &snd_timer_status_t);}' unless defined(&SND_TIMER_IOCTL_STATUS);
    eval 'sub SND_TIMER_IOCTL_START () { &_IO (ord(\'T\'), 0x20);}' unless defined(&SND_TIMER_IOCTL_START);
    eval 'sub SND_TIMER_IOCTL_STOP () { &_IO (ord(\'T\'), 0x21);}' unless defined(&SND_TIMER_IOCTL_STOP);
    eval 'sub SND_TIMER_IOCTL_CONTINUE () { &_IO (ord(\'T\'), 0x22);}' unless defined(&SND_TIMER_IOCTL_CONTINUE);
    eval 'sub SND_IOCTL_READV () { &_IOW (ord(\'K\'), 0x00,  &snd_v_args_t);}' unless defined(&SND_IOCTL_READV);
    eval 'sub SND_IOCTL_WRITEV () { &_IOW (ord(\'K\'), 0x01,  &snd_v_args_t);}' unless defined(&SND_IOCTL_WRITEV);
}
1;
