require '_h2ph_pre.ph';

unless(defined(&E_SYMNMLEN)) {
    sub E_SYMNMLEN () {	8;}
}
unless(defined(&E_FILNMLEN)) {
    sub E_FILNMLEN () {	14;}
}
unless(defined(&E_DIMNUM)) {
    sub E_DIMNUM () {	4;}
}
unless(defined(&COFF_SHORT_L)) {
    sub COFF_SHORT_L {
	local($ps) = @_;
	eval q((((($ps->[1])<<8)| (($ps->[0])))));
    }
}
unless(defined(&COFF_LONG_L)) {
    sub COFF_LONG_L {
	local($ps) = @_;
	eval q(((((($ps->[3])<<24) | (($ps->[2])<<16) | (($ps->[1])<<8) | (($ps->[0]))))));
    }
}
unless(defined(&COFF_SHORT_H)) {
    sub COFF_SHORT_H {
	local($ps) = @_;
	eval q((((($ps->[0])<<8)| (($ps->[1])))));
    }
}
unless(defined(&COFF_LONG_H)) {
    sub COFF_LONG_H {
	local($ps) = @_;
	eval q(((((($ps->[0])<<24) | (($ps->[1])<<16) | (($ps->[2])<<8) | (($ps->[3]))))));
    }
}
unless(defined(&COFF_LONG)) {
    sub COFF_LONG {
	local($v) = @_;
	eval q( &COFF_LONG_L($v));
    }
}
unless(defined(&COFF_SHORT)) {
    sub COFF_SHORT {
	local($v) = @_;
	eval q( &COFF_SHORT_L($v));
    }
}
unless(defined(&COFF_F_RELFLG)) {
    sub COFF_F_RELFLG () {	0000001;}
}
unless(defined(&COFF_F_EXEC)) {
    sub COFF_F_EXEC () {	0000002;}
}
unless(defined(&COFF_F_LNNO)) {
    sub COFF_F_LNNO () {	0000004;}
}
unless(defined(&COFF_F_LSYMS)) {
    sub COFF_F_LSYMS () {	0000010;}
}
unless(defined(&COFF_F_MINMAL)) {
    sub COFF_F_MINMAL () {	0000020;}
}
unless(defined(&COFF_F_UPDATE)) {
    sub COFF_F_UPDATE () {	0000040;}
}
unless(defined(&COFF_F_SWABD)) {
    sub COFF_F_SWABD () {	0000100;}
}
unless(defined(&COFF_F_AR16WR)) {
    sub COFF_F_AR16WR () {	0000200;}
}
unless(defined(&COFF_F_AR32WR)) {
    sub COFF_F_AR32WR () {	0000400;}
}
unless(defined(&COFF_F_AR32W)) {
    sub COFF_F_AR32W () {	0001000;}
}
unless(defined(&COFF_F_PATCH)) {
    sub COFF_F_PATCH () {	0002000;}
}
unless(defined(&COFF_F_NODF)) {
    sub COFF_F_NODF () {	0002000;}
}
unless(defined(&COFF_I386MAGIC)) {
    sub COFF_I386MAGIC () {	0x14c;}
}
if(0) {
    eval 'sub COFF_I386PTXMAGIC () {0x154;}' unless defined(&COFF_I386PTXMAGIC);
    eval 'sub COFF_I386AIXMAGIC () {0x175;}' unless defined(&COFF_I386AIXMAGIC);
    eval 'sub COFF_I386BADMAG {
        local($x) = @_;
	    eval q((( &COFF_SHORT(($x). &f_magic) !=  &COFF_I386MAGIC)  &&  &COFF_SHORT(($x). &f_magic) !=  &COFF_I386PTXMAGIC  &&  &COFF_SHORT(($x). &f_magic) !=  &COFF_I386AIXMAGIC));
    }' unless defined(&COFF_I386BADMAG);
} else {
    eval 'sub COFF_I386BADMAG {
        local($x) = @_;
	    eval q(( &COFF_SHORT(($x). &f_magic) !=  &COFF_I386MAGIC));
    }' unless defined(&COFF_I386BADMAG);
}
unless(defined(&COFF_FILHDR)) {
    sub COFF_FILHDR () {	'struct COFF_filehdr';}
}
unless(defined(&COFF_FILHSZ)) {
    sub COFF_FILHSZ () {	$sizeof{ &COFF_FILHDR};}
}
unless(defined(&COFF_AOUTSZ)) {
    sub COFF_AOUTSZ () {	($sizeof{ &COFF_AOUTHDR});}
}
unless(defined(&COFF_STMAGIC)) {
    sub COFF_STMAGIC () {	0401;}
}
unless(defined(&COFF_OMAGIC)) {
    sub COFF_OMAGIC () {	0404;}
}
unless(defined(&COFF_JMAGIC)) {
    sub COFF_JMAGIC () {	0407;}
}
unless(defined(&COFF_DMAGIC)) {
    sub COFF_DMAGIC () {	0410;}
}
unless(defined(&COFF_ZMAGIC)) {
    sub COFF_ZMAGIC () {	0413;}
}
unless(defined(&COFF_SHMAGIC)) {
    sub COFF_SHMAGIC () {	0443;}
}
unless(defined(&COFF_SCNHDR)) {
    sub COFF_SCNHDR () {	'struct COFF_scnhdr';}
}
unless(defined(&COFF_SCNHSZ)) {
    sub COFF_SCNHSZ () {	$sizeof{ &COFF_SCNHDR};}
}
unless(defined(&COFF_TEXT)) {
    sub COFF_TEXT () {	".text";}
}
unless(defined(&COFF_DATA)) {
    sub COFF_DATA () {	".data";}
}
unless(defined(&COFF_BSS)) {
    sub COFF_BSS () {	".bss";}
}
unless(defined(&COFF_COMMENT)) {
    sub COFF_COMMENT () {	".comment";}
}
unless(defined(&COFF_LIB)) {
    sub COFF_LIB () {	".lib";}
}
unless(defined(&COFF_SECT_TEXT)) {
    sub COFF_SECT_TEXT () {	0;}
}
unless(defined(&COFF_SECT_DATA)) {
    sub COFF_SECT_DATA () {	1;}
}
unless(defined(&COFF_SECT_BSS)) {
    sub COFF_SECT_BSS () {	2;}
}
unless(defined(&COFF_SECT_REQD)) {
    sub COFF_SECT_REQD () {	3;}
}
unless(defined(&COFF_STYP_REG)) {
    sub COFF_STYP_REG () {	0x00;}
}
unless(defined(&COFF_STYP_DSECT)) {
    sub COFF_STYP_DSECT () {	0x01;}
}
unless(defined(&COFF_STYP_NOLOAD)) {
    sub COFF_STYP_NOLOAD () {	0x02;}
}
unless(defined(&COFF_STYP_GROUP)) {
    sub COFF_STYP_GROUP () {	0x04;}
}
unless(defined(&COFF_STYP_PAD)) {
    sub COFF_STYP_PAD () {	0x08;}
}
unless(defined(&COFF_STYP_COPY)) {
    sub COFF_STYP_COPY () {	0x10;}
}
unless(defined(&COFF_STYP_TEXT)) {
    sub COFF_STYP_TEXT () {	0x20;}
}
unless(defined(&COFF_STYP_DATA)) {
    sub COFF_STYP_DATA () {	0x40;}
}
unless(defined(&COFF_STYP_BSS)) {
    sub COFF_STYP_BSS () {	0x80;}
}
unless(defined(&COFF_STYP_INFO)) {
    sub COFF_STYP_INFO () {	0x200;}
}
unless(defined(&COFF_STYP_OVER)) {
    sub COFF_STYP_OVER () {	0x400;}
}
unless(defined(&COFF_STYP_LIB)) {
    sub COFF_STYP_LIB () {	0x800;}
}
unless(defined(&COFF_SLIBHD)) {
    sub COFF_SLIBHD () {	'struct COFF_slib';}
}
unless(defined(&COFF_SLIBSZ)) {
    sub COFF_SLIBSZ () {	$sizeof{ &COFF_SLIBHD};}
}
unless(defined(&COFF_LINENO)) {
    sub COFF_LINENO () {	'struct COFF_lineno';}
}
unless(defined(&COFF_LINESZ)) {
    sub COFF_LINESZ () {	6;}
}
unless(defined(&COFF_E_SYMNMLEN)) {
    sub COFF_E_SYMNMLEN () {	8;}
}
unless(defined(&COFF_E_FILNMLEN)) {
    sub COFF_E_FILNMLEN () {	14;}
}
unless(defined(&COFF_E_DIMNUM)) {
    sub COFF_E_DIMNUM () {	4;}
}
unless(defined(&COFF_N_BTMASK)) {
    sub COFF_N_BTMASK () {	(0xf);}
}
unless(defined(&COFF_N_TMASK)) {
    sub COFF_N_TMASK () {	(0x30);}
}
unless(defined(&COFF_N_BTSHFT)) {
    sub COFF_N_BTSHFT () {	(4);}
}
unless(defined(&COFF_N_TSHIFT)) {
    sub COFF_N_TSHIFT () {	(2);}
}
unless(defined(&COFF_SYMENT)) {
    sub COFF_SYMENT () {	'struct COFF_syment';}
}
unless(defined(&COFF_SYMESZ)) {
    sub COFF_SYMESZ () {	18;}
}
unless(defined(&COFF_AUXENT)) {
    sub COFF_AUXENT () {	 &union  &COFF_auxent;}
}
unless(defined(&COFF_AUXESZ)) {
    sub COFF_AUXESZ () {	18;}
}
unless(defined(&COFF_ETEXT)) {
    sub COFF_ETEXT () {	"etext";}
}
unless(defined(&COFF_RELOC)) {
    sub COFF_RELOC () {	'struct COFF_reloc';}
}
unless(defined(&COFF_RELSZ)) {
    sub COFF_RELSZ () {	10;}
}
unless(defined(&COFF_DEF_DATA_SECTION_ALIGNMENT)) {
    sub COFF_DEF_DATA_SECTION_ALIGNMENT () {	4;}
}
unless(defined(&COFF_DEF_BSS_SECTION_ALIGNMENT)) {
    sub COFF_DEF_BSS_SECTION_ALIGNMENT () {	4;}
}
unless(defined(&COFF_DEF_TEXT_SECTION_ALIGNMENT)) {
    sub COFF_DEF_TEXT_SECTION_ALIGNMENT () {	4;}
}
unless(defined(&COFF_DEF_SECTION_ALIGNMENT)) {
    sub COFF_DEF_SECTION_ALIGNMENT () {	4;}
}
1;
