require '_h2ph_pre.ph';

unless(defined(&_LINUX_IP_H)) {
    eval 'sub _LINUX_IP_H () {1;}' unless defined(&_LINUX_IP_H);
    require 'asm/byteorder.ph';
    eval 'sub IPTOS_TOS_MASK () {0x1e;}' unless defined(&IPTOS_TOS_MASK);
    eval 'sub IPTOS_TOS {
        local($tos) = @_;
	    eval q((($tos) &IPTOS_TOS_MASK));
    }' unless defined(&IPTOS_TOS);
    eval 'sub IPTOS_LOWDELAY () {0x10;}' unless defined(&IPTOS_LOWDELAY);
    eval 'sub IPTOS_THROUGHPUT () {0x08;}' unless defined(&IPTOS_THROUGHPUT);
    eval 'sub IPTOS_RELIABILITY () {0x04;}' unless defined(&IPTOS_RELIABILITY);
    eval 'sub IPTOS_MINCOST () {0x02;}' unless defined(&IPTOS_MINCOST);
    eval 'sub IPTOS_PREC_MASK () {0xe0;}' unless defined(&IPTOS_PREC_MASK);
    eval 'sub IPTOS_PREC {
        local($tos) = @_;
	    eval q((($tos) &IPTOS_PREC_MASK));
    }' unless defined(&IPTOS_PREC);
    eval 'sub IPTOS_PREC_NETCONTROL () {0xe0;}' unless defined(&IPTOS_PREC_NETCONTROL);
    eval 'sub IPTOS_PREC_INTERNETCONTROL () {0xc0;}' unless defined(&IPTOS_PREC_INTERNETCONTROL);
    eval 'sub IPTOS_PREC_CRITIC_ECP () {0xa0;}' unless defined(&IPTOS_PREC_CRITIC_ECP);
    eval 'sub IPTOS_PREC_FLASHOVERRIDE () {0x80;}' unless defined(&IPTOS_PREC_FLASHOVERRIDE);
    eval 'sub IPTOS_PREC_FLASH () {0x60;}' unless defined(&IPTOS_PREC_FLASH);
    eval 'sub IPTOS_PREC_IMMEDIATE () {0x40;}' unless defined(&IPTOS_PREC_IMMEDIATE);
    eval 'sub IPTOS_PREC_PRIORITY () {0x20;}' unless defined(&IPTOS_PREC_PRIORITY);
    eval 'sub IPTOS_PREC_ROUTINE () {0x00;}' unless defined(&IPTOS_PREC_ROUTINE);
    eval 'sub IPOPT_COPY () {0x80;}' unless defined(&IPOPT_COPY);
    eval 'sub IPOPT_CLASS_MASK () {0x60;}' unless defined(&IPOPT_CLASS_MASK);
    eval 'sub IPOPT_NUMBER_MASK () {0x1f;}' unless defined(&IPOPT_NUMBER_MASK);
    eval 'sub IPOPT_COPIED {
        local($o) = @_;
	    eval q((($o) &IPOPT_COPY));
    }' unless defined(&IPOPT_COPIED);
    eval 'sub IPOPT_CLASS {
        local($o) = @_;
	    eval q((($o) &IPOPT_CLASS_MASK));
    }' unless defined(&IPOPT_CLASS);
    eval 'sub IPOPT_NUMBER {
        local($o) = @_;
	    eval q((($o) &IPOPT_NUMBER_MASK));
    }' unless defined(&IPOPT_NUMBER);
    eval 'sub IPOPT_CONTROL () {0x00;}' unless defined(&IPOPT_CONTROL);
    eval 'sub IPOPT_RESERVED1 () {0x20;}' unless defined(&IPOPT_RESERVED1);
    eval 'sub IPOPT_MEASUREMENT () {0x40;}' unless defined(&IPOPT_MEASUREMENT);
    eval 'sub IPOPT_RESERVED2 () {0x60;}' unless defined(&IPOPT_RESERVED2);
    eval 'sub IPOPT_END () {(0| &IPOPT_CONTROL);}' unless defined(&IPOPT_END);
    eval 'sub IPOPT_NOOP () {(1| &IPOPT_CONTROL);}' unless defined(&IPOPT_NOOP);
    eval 'sub IPOPT_SEC () {(2| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_SEC);
    eval 'sub IPOPT_LSRR () {(3| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_LSRR);
    eval 'sub IPOPT_TIMESTAMP () {(4| &IPOPT_MEASUREMENT);}' unless defined(&IPOPT_TIMESTAMP);
    eval 'sub IPOPT_RR () {(7| &IPOPT_CONTROL);}' unless defined(&IPOPT_RR);
    eval 'sub IPOPT_SID () {(8| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_SID);
    eval 'sub IPOPT_SSRR () {(9| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_SSRR);
    eval 'sub IPOPT_RA () {(20| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_RA);
    eval 'sub IPVERSION () {4;}' unless defined(&IPVERSION);
    eval 'sub MAXTTL () {255;}' unless defined(&MAXTTL);
    eval 'sub IPDEFTTL () {64;}' unless defined(&IPDEFTTL);
    eval 'sub IPOPT_OPTVAL () {0;}' unless defined(&IPOPT_OPTVAL);
    eval 'sub IPOPT_OLEN () {1;}' unless defined(&IPOPT_OLEN);
    eval 'sub IPOPT_OFFSET () {2;}' unless defined(&IPOPT_OFFSET);
    eval 'sub IPOPT_MINOFF () {4;}' unless defined(&IPOPT_MINOFF);
    eval 'sub MAX_IPOPTLEN () {40;}' unless defined(&MAX_IPOPTLEN);
    eval 'sub IPOPT_NOP () { &IPOPT_NOOP;}' unless defined(&IPOPT_NOP);
    eval 'sub IPOPT_EOL () { &IPOPT_END;}' unless defined(&IPOPT_EOL);
    eval 'sub IPOPT_TS () { &IPOPT_TIMESTAMP;}' unless defined(&IPOPT_TS);
    eval 'sub IPOPT_TS_TSONLY () {0;}' unless defined(&IPOPT_TS_TSONLY);
    eval 'sub IPOPT_TS_TSANDADDR () {1;}' unless defined(&IPOPT_TS_TSANDADDR);
    eval 'sub IPOPT_TS_PRESPEC () {3;}' unless defined(&IPOPT_TS_PRESPEC);
    if(defined(&__KERNEL__)) {
	eval 'sub optlength {
	    local($opt) = @_;
    	    eval q(($sizeof{\'struct ip_options\'} +  ($opt->{optlen})));
	}' unless defined(&optlength);
    }
    if(defined( &__LITTLE_ENDIAN_BITFIELD)) {
    }
 elsif(defined ( &__BIG_ENDIAN_BITFIELD)) {
    } else {
	die("Please fix <asm/byteorder.h>");
    }
}
1;
