require '_h2ph_pre.ph';

unless(defined(&_LINUX_JOYSTICK_H)) {
    eval 'sub _LINUX_JOYSTICK_H () {1;}' unless defined(&_LINUX_JOYSTICK_H);
    require 'asm/types.ph';
    require 'linux/module.ph';
    eval 'sub JS_VERSION () {0x01020f;}' unless defined(&JS_VERSION);
    eval 'sub JS_EVENT_BUTTON () {0x01;}' unless defined(&JS_EVENT_BUTTON);
    eval 'sub JS_EVENT_AXIS () {0x02;}' unless defined(&JS_EVENT_AXIS);
    eval 'sub JS_EVENT_INIT () {0x80;}' unless defined(&JS_EVENT_INIT);
    eval 'sub JSIOCGVERSION () { &_IOR(ord(\'j\'), 0x01,  &__u32);}' unless defined(&JSIOCGVERSION);
    eval 'sub JSIOCGAXES () { &_IOR(ord(\'j\'), 0x11,  &__u8);}' unless defined(&JSIOCGAXES);
    eval 'sub JSIOCGBUTTONS () { &_IOR(ord(\'j\'), 0x12,  &__u8);}' unless defined(&JSIOCGBUTTONS);
    eval 'sub JSIOCGNAME {
        local($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'j\'), 0x13, $len));
    }' unless defined(&JSIOCGNAME);
    eval 'sub JSIOCSCORR () { &_IOW(ord(\'j\'), 0x21, \'struct js_corr\');}' unless defined(&JSIOCSCORR);
    eval 'sub JSIOCGCORR () { &_IOR(ord(\'j\'), 0x22, \'struct js_corr\');}' unless defined(&JSIOCGCORR);
    eval 'sub JS_CORR_NONE () {0x00;}' unless defined(&JS_CORR_NONE);
    eval 'sub JS_CORR_BROKEN () {0x01;}' unless defined(&JS_CORR_BROKEN);
    eval 'sub JS_RETURN () {$sizeof{\'struct JS_DATA_TYPE\'};}' unless defined(&JS_RETURN);
    eval 'sub JS_TRUE () {1;}' unless defined(&JS_TRUE);
    eval 'sub JS_FALSE () {0;}' unless defined(&JS_FALSE);
    eval 'sub JS_X_0 () {0x01;}' unless defined(&JS_X_0);
    eval 'sub JS_Y_0 () {0x02;}' unless defined(&JS_Y_0);
    eval 'sub JS_X_1 () {0x04;}' unless defined(&JS_X_1);
    eval 'sub JS_Y_1 () {0x08;}' unless defined(&JS_Y_1);
    eval 'sub JS_MAX () {2;}' unless defined(&JS_MAX);
    eval 'sub JS_DEF_TIMEOUT () {0x1300;}' unless defined(&JS_DEF_TIMEOUT);
    eval 'sub JS_DEF_CORR () {0;}' unless defined(&JS_DEF_CORR);
    eval 'sub JS_DEF_TIMELIMIT () {10;}' unless defined(&JS_DEF_TIMELIMIT);
    eval 'sub JS_SET_CAL () {1;}' unless defined(&JS_SET_CAL);
    eval 'sub JS_GET_CAL () {2;}' unless defined(&JS_GET_CAL);
    eval 'sub JS_SET_TIMEOUT () {3;}' unless defined(&JS_SET_TIMEOUT);
    eval 'sub JS_GET_TIMEOUT () {4;}' unless defined(&JS_GET_TIMEOUT);
    eval 'sub JS_SET_TIMELIMIT () {5;}' unless defined(&JS_SET_TIMELIMIT);
    eval 'sub JS_GET_TIMELIMIT () {6;}' unless defined(&JS_GET_TIMELIMIT);
    eval 'sub JS_GET_ALL () {7;}' unless defined(&JS_GET_ALL);
    eval 'sub JS_SET_ALL () {8;}' unless defined(&JS_SET_ALL);
    if(defined(&__KERNEL__)) {
	eval 'sub JS_BUFF_SIZE () {64;}' unless defined(&JS_BUFF_SIZE);
	require 'linux/version.ph';
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,2,0)) {
	    die("You need to use at least v2.2 Linux kernel.");
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,3,0)) {
	    require 'asm/spinlock.ph';
	    eval 'sub __exit () {1;}' unless defined(&__exit);
	    if(defined(&MODULE)) {
		eval 'sub module_init {
		    local($x) = @_;
    		    eval q(\'int\'  &init_module( &void) {  &return $x(); });
		}' unless defined(&module_init);
		eval 'sub module_exit {
		    local($x) = @_;
    		    eval q( &void  &cleanup_module( &void) { $x(); });
		}' unless defined(&module_exit);
	    } else {
		eval 'sub module_init {
		    local($x) = @_;
    		    eval q(\'int\' $x &_module( &void) {  &return $x(); });
		}' unless defined(&module_init);
		eval 'sub module_exit {
		    local($x) = @_;
    		    eval q( &void $x &_module( &void) { $x(); });
		}' unless defined(&module_exit);
	    }
	    eval 'sub __setup {
	        local($a,$b) = @_;
    		eval q();
	    }' unless defined(&__setup);
	    eval 'sub BASE_ADDRESS {
	        local($x,$i) = @_;
    		eval q((($x)-> $base_address[$i]));
	    }' unless defined(&BASE_ADDRESS);
	    eval 'sub DECLARE_WAITQUEUE {
	        local($x,$y) = @_;
    		eval q(\'struct wait_queue\' $x = { $y,  &NULL });
	    }' unless defined(&DECLARE_WAITQUEUE);
	    eval 'sub init_waitqueue_head {
	        local($x) = @_;
    		eval q( &do { *($x) =  &NULL; }  &while (0));
	    }' unless defined(&init_waitqueue_head);
	    eval 'sub __set_current_state {
	        local($x) = @_;
    		eval q( ($current->{state}) = $x);
	    }' unless defined(&__set_current_state);
	    eval 'sub SETUP_PARAM () {\'char\' * &str, \'int\' * &ints;}' unless defined(&SETUP_PARAM);
	    eval 'sub SETUP_PARSE {
	        local($x) = @_;
    		eval q( &do {}  &while (0));
	    }' unless defined(&SETUP_PARSE);
	} else {
	    require 'linux/spinlock.ph';
	    eval 'sub BASE_ADDRESS {
	        local($x,$i) = @_;
    		eval q((($x)-> ($resource[$i]->{start})));
	    }' unless defined(&BASE_ADDRESS);
	    eval 'sub SETUP_PARAM () {\'char\' * &str;}' unless defined(&SETUP_PARAM);
	    eval 'sub SETUP_PARSE {
	        local($x) = @_;
    		eval q(\'int\'  $ints[$x];  &get_options( &str, $x,  &ints));
	    }' unless defined(&SETUP_PARSE);
	}
	eval 'sub PCI_VENDOR_ID_AUREAL () {0x12eb;}' unless defined(&PCI_VENDOR_ID_AUREAL);
	require 'linux/parport.ph';
	eval 'sub JS_PAR_STATUS_INVERT () {(0x80);}' unless defined(&JS_PAR_STATUS_INVERT);
	eval 'sub JS_PAR_CTRL_INVERT () {(0x04);}' unless defined(&JS_PAR_CTRL_INVERT);
	eval 'sub JS_PAR_DATA_IN {
	    local($y) = @_;
    	    eval q( &parport_read_data( ($y->{port})));
	}' unless defined(&JS_PAR_DATA_IN);
	eval 'sub JS_PAR_DATA_OUT {
	    local($x,$y) = @_;
    	    eval q( &parport_write_data( ($y->{port}), $x));
	}' unless defined(&JS_PAR_DATA_OUT);
	eval 'sub JS_PAR_STATUS {
	    local($y) = @_;
    	    eval q( &parport_read_status( ($y->{port})));
	}' unless defined(&JS_PAR_STATUS);
	unless(defined(&PARPORT_NEED_GENERIC_OPS)) {
	    eval 'sub JS_PAR_CTRL_IN {
	        local($y) = @_;
    		eval q( &parport_read_control( ($y->{port})));
	    }' unless defined(&JS_PAR_CTRL_IN);
	} else {
	    eval 'sub JS_PAR_CTRL_IN {
	        local($y) = @_;
    		eval q( &inb( ($y->{port}->{base})+2));
	    }' unless defined(&JS_PAR_CTRL_IN);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,3,0)) {
	    eval 'sub JS_PAR_CTRL_OUT {
	        local($x,$y) = @_;
    		eval q( &parport_write_control( ($y->{port}), $x));
	    }' unless defined(&JS_PAR_CTRL_OUT);
	    eval 'sub JS_PAR_ECTRL_OUT {
	        local($x,$y) = @_;
    		eval q( &parport_write_econtrol( ($y->{port}), $x));
	    }' unless defined(&JS_PAR_ECTRL_OUT);
	} else {
	    eval 'sub JS_PAR_CTRL_OUT {
	        local($x,$y) = @_;
    		eval q( &do {  &if (($x) & 0x20)  &parport_data_reverse( ($y->{port}));  &else  &parport_data_forward( ($y->{port}));  &parport_write_control( ($y->{port}), ($x) & ~0x20); }  &while (0));
	    }' unless defined(&JS_PAR_CTRL_OUT);
	    eval 'sub JS_PAR_ECTRL_OUT {
	        local($x,$y) = @_;
    		eval q();
	    }' unless defined(&JS_PAR_ECTRL_OUT);
	    eval 'sub PARPORT_MODE_PCPS2 () { &PARPORT_MODE_TRISTATE;}' unless defined(&PARPORT_MODE_PCPS2);
	    eval 'sub PARPORT_MODE_PCECPPS2 () { &PARPORT_MODE_TRISTATE;}' unless defined(&PARPORT_MODE_PCECPPS2);
	}
    }
}
1;
