require '_h2ph_pre.ph';

unless(defined(&_LINUX_MM_H)) {
    eval 'sub _LINUX_MM_H () {1;}' unless defined(&_LINUX_MM_H);
    require 'linux/sched.ph';
    require 'linux/errno.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/string.ph';
	require 'asm/page.ph';
	require 'asm/atomic.ph';
	eval 'sub VM_READ () {0x0001;}' unless defined(&VM_READ);
	eval 'sub VM_WRITE () {0x0002;}' unless defined(&VM_WRITE);
	eval 'sub VM_EXEC () {0x0004;}' unless defined(&VM_EXEC);
	eval 'sub VM_SHARED () {0x0008;}' unless defined(&VM_SHARED);
	eval 'sub VM_MAYREAD () {0x0010;}' unless defined(&VM_MAYREAD);
	eval 'sub VM_MAYWRITE () {0x0020;}' unless defined(&VM_MAYWRITE);
	eval 'sub VM_MAYEXEC () {0x0040;}' unless defined(&VM_MAYEXEC);
	eval 'sub VM_MAYSHARE () {0x0080;}' unless defined(&VM_MAYSHARE);
	eval 'sub VM_GROWSDOWN () {0x0100;}' unless defined(&VM_GROWSDOWN);
	eval 'sub VM_GROWSUP () {0x0200;}' unless defined(&VM_GROWSUP);
	eval 'sub VM_SHM () {0x0400;}' unless defined(&VM_SHM);
	eval 'sub VM_DENYWRITE () {0x0800;}' unless defined(&VM_DENYWRITE);
	eval 'sub VM_EXECUTABLE () {0x1000;}' unless defined(&VM_EXECUTABLE);
	eval 'sub VM_LOCKED () {0x2000;}' unless defined(&VM_LOCKED);
	eval 'sub VM_IO () {0x4000;}' unless defined(&VM_IO);
	eval 'sub VM_STACK_FLAGS () {0x0177;}' unless defined(&VM_STACK_FLAGS);
	eval 'sub PG_locked () {0;}' unless defined(&PG_locked);
	eval 'sub PG_error () {1;}' unless defined(&PG_error);
	eval 'sub PG_referenced () {2;}' unless defined(&PG_referenced);
	eval 'sub PG_dirty () {3;}' unless defined(&PG_dirty);
	eval 'sub PG_uptodate () {4;}' unless defined(&PG_uptodate);
	eval 'sub PG_free_after () {5;}' unless defined(&PG_free_after);
	eval 'sub PG_decr_after () {6;}' unless defined(&PG_decr_after);
	eval 'sub PG_swap_unlock_after () {7;}' unless defined(&PG_swap_unlock_after);
	eval 'sub PG_DMA () {8;}' unless defined(&PG_DMA);
	eval 'sub PG_Slab () {9;}' unless defined(&PG_Slab);
	eval 'sub PG_swap_cache () {10;}' unless defined(&PG_swap_cache);
	eval 'sub PG_skip () {11;}' unless defined(&PG_skip);
	eval 'sub PG_reserved () {31;}' unless defined(&PG_reserved);
	eval 'sub PageLocked {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_locked, ($page)-> &flags)));
	}' unless defined(&PageLocked);
	eval 'sub PageError {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_error, ($page)-> &flags)));
	}' unless defined(&PageError);
	eval 'sub PageReferenced {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_referenced, ($page)-> &flags)));
	}' unless defined(&PageReferenced);
	eval 'sub PageDirty {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_dirty, ($page)-> &flags)));
	}' unless defined(&PageDirty);
	eval 'sub PageUptodate {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_uptodate, ($page)-> &flags)));
	}' unless defined(&PageUptodate);
	eval 'sub PageFreeAfter {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_free_after, ($page)-> &flags)));
	}' unless defined(&PageFreeAfter);
	eval 'sub PageDecrAfter {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_decr_after, ($page)-> &flags)));
	}' unless defined(&PageDecrAfter);
	eval 'sub PageSwapUnlockAfter {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_swap_unlock_after, ($page)-> &flags)));
	}' unless defined(&PageSwapUnlockAfter);
	eval 'sub PageDMA {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_DMA, ($page)-> &flags)));
	}' unless defined(&PageDMA);
	eval 'sub PageSlab {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_Slab, ($page)-> &flags)));
	}' unless defined(&PageSlab);
	eval 'sub PageSwapCache {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_swap_cache, ($page)-> &flags)));
	}' unless defined(&PageSwapCache);
	eval 'sub PageReserved {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_reserved, ($page)-> &flags)));
	}' unless defined(&PageReserved);
	eval 'sub PageSetSlab {
	    local($page) = @_;
    	    eval q(( &set_bit( &PG_Slab, ($page)-> &flags)));
	}' unless defined(&PageSetSlab);
	eval 'sub PageSetSwapCache {
	    local($page) = @_;
    	    eval q(( &set_bit( &PG_swap_cache, ($page)-> &flags)));
	}' unless defined(&PageSetSwapCache);
	eval 'sub PageTestandSetDirty {
	    local($page) = @_;
    	    eval q(( &test_and_set_bit( &PG_dirty, ($page)-> &flags)));
	}' unless defined(&PageTestandSetDirty);
	eval 'sub PageTestandSetSwapCache {
	    local($page) = @_;
    	    eval q(( &test_and_set_bit( &PG_swap_cache, ($page)-> &flags)));
	}' unless defined(&PageTestandSetSwapCache);
	eval 'sub PageClearSlab {
	    local($page) = @_;
    	    eval q(( &clear_bit( &PG_Slab, ($page)-> &flags)));
	}' unless defined(&PageClearSlab);
	eval 'sub PageClearSwapCache {
	    local($page) = @_;
    	    eval q(( &clear_bit( &PG_swap_cache, ($page)-> &flags)));
	}' unless defined(&PageClearSwapCache);
	eval 'sub PageTestandClearDirty {
	    local($page) = @_;
    	    eval q(( &test_and_clear_bit( &PG_dirty, ($page)-> &flags)));
	}' unless defined(&PageTestandClearDirty);
	eval 'sub PageTestandClearSwapCache {
	    local($page) = @_;
    	    eval q(( &test_and_clear_bit( &PG_swap_cache, ($page)-> &flags)));
	}' unless defined(&PageTestandClearSwapCache);
	eval 'sub __get_free_page {
	    local($gfp_mask) = @_;
    	    eval q( &__get_free_pages(($gfp_mask),0));
	}' unless defined(&__get_free_page);
	eval 'sub __get_dma_pages {
	    local($gfp_mask, $order) = @_;
    	    eval q( &__get_free_pages(($gfp_mask) |  &GFP_DMA,($order)));
	}' unless defined(&__get_dma_pages);
	eval 'sub free_page {
	    local($addr) = @_;
    	    eval q( &free_pages(($addr),0));
	}' unless defined(&free_page);
	eval 'sub __free_page {
	    local($page) = @_;
    	    eval q( &__free_pages(($page),0));
	}' unless defined(&__free_page);
	eval 'sub __GFP_WAIT () {0x01;}' unless defined(&__GFP_WAIT);
	eval 'sub __GFP_LOW () {0x02;}' unless defined(&__GFP_LOW);
	eval 'sub __GFP_MED () {0x04;}' unless defined(&__GFP_MED);
	eval 'sub __GFP_HIGH () {0x08;}' unless defined(&__GFP_HIGH);
	eval 'sub __GFP_IO () {0x10;}' unless defined(&__GFP_IO);
	eval 'sub __GFP_SWAP () {0x20;}' unless defined(&__GFP_SWAP);
	eval 'sub __GFP_DMA () {0x80;}' unless defined(&__GFP_DMA);
	eval 'sub GFP_BUFFER () {( &__GFP_MED |  &__GFP_WAIT);}' unless defined(&GFP_BUFFER);
	eval 'sub GFP_ATOMIC () {( &__GFP_HIGH);}' unless defined(&GFP_ATOMIC);
	eval 'sub GFP_USER () {( &__GFP_LOW |  &__GFP_WAIT |  &__GFP_IO);}' unless defined(&GFP_USER);
	eval 'sub GFP_KERNEL () {( &__GFP_MED |  &__GFP_WAIT |  &__GFP_IO);}' unless defined(&GFP_KERNEL);
	eval 'sub GFP_NFS () {( &__GFP_HIGH |  &__GFP_WAIT |  &__GFP_IO);}' unless defined(&GFP_NFS);
	eval 'sub GFP_KSWAPD () {( &__GFP_IO |  &__GFP_SWAP);}' unless defined(&GFP_KSWAPD);
	eval 'sub GFP_DMA () { &__GFP_DMA;}' unless defined(&GFP_DMA);
	eval 'sub buffer_under_min () {
	    eval q((( &buffermem >>  &PAGE_SHIFT) * 100<  ($buffer_mem->{min_percent}) *  &num_physpages));
	}' unless defined(&buffer_under_min);
	eval 'sub pgcache_under_min () {
	    eval q(( &page_cache_size * 100<  ($page_cache->{min_percent}) *  &num_physpages));
	}' unless defined(&pgcache_under_min);
    }
}
1;
