require '_h2ph_pre.ph';

unless(defined(&_LINUX_NFS_FS_H)) {
    eval 'sub _LINUX_NFS_FS_H () {1;}' unless defined(&_LINUX_NFS_FS_H);
    require 'linux/signal.ph';
    require 'linux/sched.ph';
    require 'linux/in.ph';
    require 'linux/sunrpc/sched.ph';
    require 'linux/nfs.ph';
    require 'linux/nfs_mount.ph';
    if(defined(&RPC_DEBUG)) {
	eval 'sub NFS_DEBUG () {1;}' unless defined(&NFS_DEBUG);
    }
    eval 'sub NFS_MAX_DIRCACHE () {16;}' unless defined(&NFS_MAX_DIRCACHE);
    eval 'sub NFS_MAX_FILE_IO_BUFFER_SIZE () {16384;}' unless defined(&NFS_MAX_FILE_IO_BUFFER_SIZE);
    eval 'sub NFS_DEF_FILE_IO_BUFFER_SIZE () {4096;}' unless defined(&NFS_DEF_FILE_IO_BUFFER_SIZE);
    eval 'sub NFS_MAX_RPC_TIMEOUT () {(6* &HZ);}' unless defined(&NFS_MAX_RPC_TIMEOUT);
    eval 'sub NFS_LOOKUP_CACHE_SIZE () {64;}' unless defined(&NFS_LOOKUP_CACHE_SIZE);
    eval 'sub NFS_SUPER_MAGIC () {0x6969;}' unless defined(&NFS_SUPER_MAGIC);
    eval 'sub NFS_FH {
        local($dentry) = @_;
	    eval q(( (($dentry)-> &d_fsdata)));
    }' unless defined(&NFS_FH);
    eval 'sub NFS_DSERVER {
        local($dentry) = @_;
	    eval q((($dentry)-> ($d_sb->{u}->{nfs_sb}->{s_server})));
    }' unless defined(&NFS_DSERVER);
    eval 'sub NFS_SERVER {
        local($inode) = @_;
	    eval q((($inode)-> ($i_sb->{u}->{nfs_sb}->{s_server})));
    }' unless defined(&NFS_SERVER);
    eval 'sub NFS_CLIENT {
        local($inode) = @_;
	    eval q(( &NFS_SERVER($inode)-> &client));
    }' unless defined(&NFS_CLIENT);
    eval 'sub NFS_ADDR {
        local($inode) = @_;
	    eval q(( &RPC_PEERADDR( &NFS_CLIENT($inode))));
    }' unless defined(&NFS_ADDR);
    eval 'sub NFS_CONGESTED {
        local($inode) = @_;
	    eval q(( &RPC_CONGESTED( &NFS_CLIENT($inode))));
    }' unless defined(&NFS_CONGESTED);
    eval 'sub NFS_READTIME {
        local($inode) = @_;
	    eval q((($inode)-> ($u->{nfs_i}->{read_cache_jiffies})));
    }' unless defined(&NFS_READTIME);
    eval 'sub NFS_OLDMTIME {
        local($inode) = @_;
	    eval q((($inode)-> ($u->{nfs_i}->{read_cache_mtime})));
    }' unless defined(&NFS_OLDMTIME);
    eval 'sub NFS_CACHEINV {
        local($inode) = @_;
	    eval q( &do {  &NFS_READTIME($inode) =  &jiffies - 1000000;  &NFS_OLDMTIME($inode) = 0; }  &while (0));
    }' unless defined(&NFS_CACHEINV);
    eval 'sub NFS_ATTRTIMEO {
        local($inode) = @_;
	    eval q((($inode)-> ($u->{nfs_i}->{attrtimeo})));
    }' unless defined(&NFS_ATTRTIMEO);
    eval 'sub NFS_MINATTRTIMEO {
        local($inode) = @_;
	    eval q(( &S_ISDIR( ($inode->{i_mode}))?  &NFS_SERVER($inode)-> &acdirmin :  &NFS_SERVER($inode)-> &acregmin));
    }' unless defined(&NFS_MINATTRTIMEO);
    eval 'sub NFS_MAXATTRTIMEO {
        local($inode) = @_;
	    eval q(( &S_ISDIR( ($inode->{i_mode}))?  &NFS_SERVER($inode)-> &acdirmax :  &NFS_SERVER($inode)-> &acregmax));
    }' unless defined(&NFS_MAXATTRTIMEO);
    eval 'sub NFS_FLAGS {
        local($inode) = @_;
	    eval q((($inode)-> ($u->{nfs_i}->{flags})));
    }' unless defined(&NFS_FLAGS);
    eval 'sub NFS_REVALIDATING {
        local($inode) = @_;
	    eval q(( &NFS_FLAGS($inode) &  &NFS_INO_REVALIDATE));
    }' unless defined(&NFS_REVALIDATING);
    eval 'sub NFS_WRITEBACK {
        local($inode) = @_;
	    eval q((($inode)-> ($u->{nfs_i}->{writeback})));
    }' unless defined(&NFS_WRITEBACK);
    eval 'sub NFS_RPC_SWAPFLAGS () {( &RPC_TASK_SWAPPER| &RPC_TASK_ROOTCREDS);}' unless defined(&NFS_RPC_SWAPFLAGS);
    eval 'sub NFS_CLNTF_BUFSIZE () {0x0001;}' unless defined(&NFS_CLNTF_BUFSIZE);
    if(defined(&__KERNEL__)) {
	eval 'sub WB_NEXT {
	    local($req) = @_;
    	    eval q(( (($req)-> ($wb_list->{next}))));
	}' unless defined(&WB_NEXT);
	eval 'sub NFS_WRITE_CANCELLED () {0x0004;}' unless defined(&NFS_WRITE_CANCELLED);
	eval 'sub NFS_WRITE_UNCOMMITTED () {0x0008;}' unless defined(&NFS_WRITE_UNCOMMITTED);
	eval 'sub NFS_WRITE_INVALIDATE () {0x0010;}' unless defined(&NFS_WRITE_INVALIDATE);
	eval 'sub NFS_WRITE_INPROGRESS () {0x0100;}' unless defined(&NFS_WRITE_INPROGRESS);
	eval 'sub NFS_WRITE_COMPLETE () {0x0200;}' unless defined(&NFS_WRITE_COMPLETE);
	eval 'sub WB_CANCELLED {
	    local($req) = @_;
    	    eval q((($req)-> &wb_flags &  &NFS_WRITE_CANCELLED));
	}' unless defined(&WB_CANCELLED);
	eval 'sub WB_UNCOMMITTED {
	    local($req) = @_;
    	    eval q((($req)-> &wb_flags &  &NFS_WRITE_UNCOMMITTED));
	}' unless defined(&WB_UNCOMMITTED);
	eval 'sub WB_INVALIDATE {
	    local($req) = @_;
    	    eval q((($req)-> &wb_flags &  &NFS_WRITE_INVALIDATE));
	}' unless defined(&WB_INVALIDATE);
	eval 'sub WB_INPROGRESS {
	    local($req) = @_;
    	    eval q((($req)-> &wb_flags &  &NFS_WRITE_INPROGRESS));
	}' unless defined(&WB_INPROGRESS);
	eval 'sub WB_COMPLETE {
	    local($req) = @_;
    	    eval q((($req)-> &wb_flags &  &NFS_WRITE_COMPLETE));
	}' unless defined(&WB_COMPLETE);
    }
    eval 'sub NFSDBG_VFS () {0x0001;}' unless defined(&NFSDBG_VFS);
    eval 'sub NFSDBG_DIRCACHE () {0x0002;}' unless defined(&NFSDBG_DIRCACHE);
    eval 'sub NFSDBG_LOOKUPCACHE () {0x0004;}' unless defined(&NFSDBG_LOOKUPCACHE);
    eval 'sub NFSDBG_PAGECACHE () {0x0008;}' unless defined(&NFSDBG_PAGECACHE);
    eval 'sub NFSDBG_PROC () {0x0010;}' unless defined(&NFSDBG_PROC);
    eval 'sub NFSDBG_XDR () {0x0020;}' unless defined(&NFSDBG_XDR);
    eval 'sub NFSDBG_FILE () {0x0040;}' unless defined(&NFSDBG_FILE);
    eval 'sub NFSDBG_ROOT () {0x0080;}' unless defined(&NFSDBG_ROOT);
    eval 'sub NFSDBG_ALL () {0xffff;}' unless defined(&NFSDBG_ALL);
    if(defined(&__KERNEL__)) {
	undef(&ifdebug) if defined(&ifdebug);
	if(defined(&NFS_DEBUG)) {
	    eval 'sub ifdebug {
	        local($fac) = @_;
    		eval q( &if ( &nfs_debug &  &NFSDBG_$fac));
	    }' unless defined(&ifdebug);
	} else {
	    eval 'sub ifdebug {
	        local($fac) = @_;
    		eval q( &if (0));
	    }' unless defined(&ifdebug);
	}
    }
}
1;
