require '_h2ph_pre.ph';

unless(defined(&_LINUX_SCHED_H)) {
    eval 'sub _LINUX_SCHED_H () {1;}' unless defined(&_LINUX_SCHED_H);
    require 'asm/param.ph';
    require 'linux/binfmts.ph';
    require 'linux/personality.ph';
    require 'linux/tasks.ph';
    require 'linux/kernel.ph';
    require 'linux/types.ph';
    require 'linux/times.ph';
    require 'linux/timex.ph';
    require 'asm/system.ph';
    require 'asm/semaphore.ph';
    require 'asm/page.ph';
    require 'linux/smp.ph';
    require 'linux/tty.ph';
    require 'linux/sem.ph';
    require 'linux/signal.ph';
    require 'linux/securebits.ph';
    eval 'sub CSIGNAL () {0x000000ff;}' unless defined(&CSIGNAL);
    eval 'sub CLONE_VM () {0x00000100;}' unless defined(&CLONE_VM);
    eval 'sub CLONE_FS () {0x00000200;}' unless defined(&CLONE_FS);
    eval 'sub CLONE_FILES () {0x00000400;}' unless defined(&CLONE_FILES);
    eval 'sub CLONE_SIGHAND () {0x00000800;}' unless defined(&CLONE_SIGHAND);
    eval 'sub CLONE_PID () {0x00001000;}' unless defined(&CLONE_PID);
    eval 'sub CLONE_PTRACE () {0x00002000;}' unless defined(&CLONE_PTRACE);
    eval 'sub CLONE_VFORK () {0x00004000;}' unless defined(&CLONE_VFORK);
    eval 'sub FSHIFT () {11;}' unless defined(&FSHIFT);
    eval 'sub FIXED_1 () {(1<< &FSHIFT);}' unless defined(&FIXED_1);
    eval 'sub LOAD_FREQ () {(5* &HZ);}' unless defined(&LOAD_FREQ);
    eval 'sub EXP_1 () {1884;}' unless defined(&EXP_1);
    eval 'sub EXP_5 () {2014;}' unless defined(&EXP_5);
    eval 'sub EXP_15 () {2037;}' unless defined(&EXP_15);
    eval 'sub CALC_LOAD {
        local($load,$exp,$n) = @_;
	    eval q($load *= $exp; $load += $n*( &FIXED_1-$exp); $load >>=  &FSHIFT;);
    }' unless defined(&CALC_LOAD);
    eval 'sub CT_TO_SECS {
        local($x) = @_;
	    eval q((($x) /  &HZ));
    }' unless defined(&CT_TO_SECS);
    eval 'sub CT_TO_USECS {
        local($x) = @_;
	    eval q(((($x) %  &HZ) * 1000000/ &HZ));
    }' unless defined(&CT_TO_USECS);
    require 'linux/fs.ph';
    require 'linux/time.ph';
    require 'linux/param.ph';
    require 'linux/resource.ph';
    require 'linux/timer.ph';
    require 'asm/processor.ph';
    eval 'sub TASK_RUNNING () {0;}' unless defined(&TASK_RUNNING);
    eval 'sub TASK_INTERRUPTIBLE () {1;}' unless defined(&TASK_INTERRUPTIBLE);
    eval 'sub TASK_UNINTERRUPTIBLE () {2;}' unless defined(&TASK_UNINTERRUPTIBLE);
    eval 'sub TASK_ZOMBIE () {4;}' unless defined(&TASK_ZOMBIE);
    eval 'sub TASK_STOPPED () {8;}' unless defined(&TASK_STOPPED);
    eval 'sub TASK_SWAPPING () {16;}' unless defined(&TASK_SWAPPING);
    eval 'sub SCHED_OTHER () {0;}' unless defined(&SCHED_OTHER);
    eval 'sub SCHED_FIFO () {1;}' unless defined(&SCHED_FIFO);
    eval 'sub SCHED_RR () {2;}' unless defined(&SCHED_RR);
    eval 'sub SCHED_YIELD () {0x10;}' unless defined(&SCHED_YIELD);
    if(defined(&__KERNEL__)) {
	require 'asm/spinlock.ph';
	eval 'sub MAX_SCHEDULE_TIMEOUT () { &LONG_MAX;}' unless defined(&MAX_SCHEDULE_TIMEOUT);
	eval 'sub NR_OPEN_DEFAULT () { &BITS_PER_LONG;}' unless defined(&NR_OPEN_DEFAULT);
	eval 'sub INIT_FILES () {{  &ATOMIC_INIT(1),  &NR_OPEN_DEFAULT,  &__FD_SETSIZE, 0,  ($init_files->{fd_array[0]}),  ($init_files->{close_on_exec_init}),  ($init_files->{open_fds_init}), { { 0, } }, { { 0, } }, {  &NULL, } };}' unless defined(&INIT_FILES);
	eval 'sub INIT_FS () {{  &ATOMIC_INIT(1), 0022,  &NULL,  &NULL };}' unless defined(&INIT_FS);
	eval 'sub MAX_MAP_COUNT () {(65536);}' unless defined(&MAX_MAP_COUNT);
	eval 'sub AVL_MIN_MAP_COUNT () {32;}' unless defined(&AVL_MIN_MAP_COUNT);
	eval 'sub INIT_MM () {{  &init_mmap,  &NULL,  &NULL,  &swapper_pg_dir,  &ATOMIC_INIT(1), 1,  &MUTEX, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  &NULL };}' unless defined(&INIT_MM);
	eval 'sub INIT_SIGNALS () {{  &ATOMIC_INIT(1), { {{0,}}, },  &SPIN_LOCK_UNLOCKED };}' unless defined(&INIT_SIGNALS);
	eval 'sub PF_ALIGNWARN () {0x00000001;}' unless defined(&PF_ALIGNWARN);
	eval 'sub PF_STARTING () {0x00000002;}' unless defined(&PF_STARTING);
	eval 'sub PF_EXITING () {0x00000004;}' unless defined(&PF_EXITING);
	eval 'sub PF_PTRACED () {0x00000010;}' unless defined(&PF_PTRACED);
	eval 'sub PF_TRACESYS () {0x00000020;}' unless defined(&PF_TRACESYS);
	eval 'sub PF_FORKNOEXEC () {0x00000040;}' unless defined(&PF_FORKNOEXEC);
	eval 'sub PF_SUPERPRIV () {0x00000100;}' unless defined(&PF_SUPERPRIV);
	eval 'sub PF_DUMPCORE () {0x00000200;}' unless defined(&PF_DUMPCORE);
	eval 'sub PF_SIGNALED () {0x00000400;}' unless defined(&PF_SIGNALED);
	eval 'sub PF_MEMALLOC () {0x00000800;}' unless defined(&PF_MEMALLOC);
	eval 'sub PF_VFORK () {0x00001000;}' unless defined(&PF_VFORK);
	eval 'sub PF_USEDFPU () {0x00100000;}' unless defined(&PF_USEDFPU);
	eval 'sub PF_DTRACE () {0x00200000;}' unless defined(&PF_DTRACE);
	eval 'sub _STK_LIM () {(8*1024*1024);}' unless defined(&_STK_LIM);
	eval 'sub DEF_PRIORITY () {(20* &HZ/100);}' unless defined(&DEF_PRIORITY);
	eval 'sub INIT_TASK () {{ 0,0,0, &KERNEL_DS, &default_exec_domain,0,  &DEF_PRIORITY, &DEF_PRIORITY,0, 0,0,0,-1,  &init_task, &init_task,  &init_task,  &init_task,  &NULL, 0,0,0,0,0,0, 0,0,0,0,0,  &init_task, &init_task, &NULL, &NULL, &NULL,  &NULL,  &NULL,  $task[0],  &NULL,  &NULL,  &SCHED_OTHER,0,0,0,0,0,0,0, {  &NULL,  &NULL, 0, 0,  &it_real_fn }, {0,0,0,0},0, {0, }, {0, }, 0,0,0,0,0,0, 0,0, 0,0,0,0,0,0,0,0, 0, {0,},  &CAP_INIT_EFF_SET, &CAP_INIT_INH_SET, &CAP_FULL_SET,  &NULL,  &INIT_RLIMITS, 0, "swapper", 0, &NULL,  &NULL,  &NULL,  &INIT_TSS,  &init_fs,  &init_files,  &init_mm,  &SPIN_LOCK_UNLOCKED,  &init_signals, {{0}}, {{0}},  &NULL,  ($init_task->{sigqueue}), 0, 0, 0,0, 0, };}' unless defined(&INIT_TASK);
	eval 'sub PIDHASH_SZ () {( &NR_TASKS >> 2);}' unless defined(&PIDHASH_SZ);
	eval 'sub pid_hashfn {
	    local($x) = @_;
    	    eval q((((($x) >> 8) ^ ($x)) & ( &PIDHASH_SZ - 1)));
	}' unless defined(&pid_hashfn);
	require 'asm/current.ph';
	eval 'sub CURRENT_TIME () {( ($xtime->{tv_sec}));}' unless defined(&CURRENT_TIME);
	eval 'sub wake_up {
	    local($x) = @_;
    	    eval q( &__wake_up(($x), &TASK_UNINTERRUPTIBLE |  &TASK_INTERRUPTIBLE));
	}' unless defined(&wake_up);
	eval 'sub wake_up_interruptible {
	    local($x) = @_;
    	    eval q( &__wake_up(($x), &TASK_INTERRUPTIBLE));
	}' unless defined(&wake_up_interruptible);
	if(1) {
	} else {
	}
	if(defined(&FDSET_DEBUG)) {
	}
	if(defined(&FDSET_DEBUG)) {
	}
	eval 'sub __wait_event {
	    local($wq, $condition) = @_;
    	    eval q( &do { \'struct wait_queue\'  &__wait;  ($__wait->{task}) =  &current;  &add_wait_queue($wq, & &__wait);  &for (;;) {  ($current->{state}) =  &TASK_UNINTERRUPTIBLE;  &mb();  &if  &break;  &schedule(); }  ($current->{state}) =  &TASK_RUNNING;  &remove_wait_queue($wq, & &__wait); }  &while (0));
	}' unless defined(&__wait_event);
	eval 'sub wait_event {
	    local($wq, $condition) = @_;
    	    eval q( &do {  &if  &break;  &__wait_event($wq, $condition); }  &while (0));
	}' unless defined(&wait_event);
	eval 'sub __wait_event_interruptible {
	    local($wq, $condition, $ret) = @_;
    	    eval q( &do { \'struct wait_queue\'  &__wait;  ($__wait->{task}) =  &current;  &add_wait_queue($wq, & &__wait);  &for (;;) {  ($current->{state}) =  &TASK_INTERRUPTIBLE;  &mb();  &if  &break;  &if (! &signal_pending( &current)) {  &schedule();  &continue; } $ret = - &ERESTARTSYS;  &break; }  ($current->{state}) =  &TASK_RUNNING;  &remove_wait_queue($wq, & &__wait); }  &while (0));
	}' unless defined(&__wait_event_interruptible);
	eval 'sub wait_event_interruptible {
	    local($wq, $condition) = @_;
    	    eval q(({ \'int\'  &__ret = 0;  &if (!($condition))  &__wait_event_interruptible($wq, $condition,  &__ret);  &__ret; }));
	}' unless defined(&wait_event_interruptible);
	eval 'sub REMOVE_LINKS {
	    local($p) = @_;
    	    eval q( &do { ($p)-> ($next_task->{prev_task}) = ($p)-> &prev_task; ($p)-> ($prev_task->{next_task}) = ($p)-> &next_task;  &if (($p)-> &p_osptr) ($p)-> ($p_osptr->{p_ysptr}) = ($p)-> &p_ysptr;  &if (($p)-> &p_ysptr) ($p)-> ($p_ysptr->{p_osptr}) = ($p)-> &p_osptr;  &else ($p)-> ($p_pptr->{p_cptr}) = ($p)-> &p_osptr; }  &while (0));
	}' unless defined(&REMOVE_LINKS);
	eval 'sub SET_LINKS {
	    local($p) = @_;
    	    eval q( &do { ($p)-> &next_task =  &init_task; ($p)-> &prev_task =  ($init_task->{prev_task});  ($init_task->{prev_task}->{next_task}) = ($p);  ($init_task->{prev_task}) = ($p); ($p)-> &p_ysptr =  &NULL;  &if ((($p)-> &p_osptr = ($p)-> ($p_pptr->{p_cptr})) !=  &NULL) ($p)-> ($p_osptr->{p_ysptr}) = $p; ($p)-> ($p_pptr->{p_cptr}) = $p; }  &while (0));
	}' unless defined(&SET_LINKS);
	eval 'sub for_each_task {
	    local($p) = @_;
    	    eval q( &for ($p =  &init_task ; ($p =  ($p->{next_task})) !=  &init_task ; ));
	}' unless defined(&for_each_task);
    }
}
1;
